﻿Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.json

Namespace AdvSoft.UtilitiesLayer

    Public Class JSONUtilities

        ' http://msdn.microsoft.com/en-us/library/bb410770.aspx
        ' http://pietschsoft.com/post/2008/02/NET-35-JSON-Serialization-using-the-DataContractJsonSerializer.aspx
        ' http://msdn.microsoft.com/en-us/library/bb299886.aspx

        Public Shared Function Serialize(Of T)(obj As T) As String
            Dim serializer As New System.Runtime.Serialization.Json.DataContractJsonSerializer(obj.[GetType]())
            Dim ms As New IO.MemoryStream()
            serializer.WriteObject(ms, obj)
            Dim retVal As String = Encoding.[Default].GetString(ms.ToArray())
            ms.Dispose()
            Return retVal
        End Function

        Public Shared Function Deserialize(Of T)(json As String) As T
            Dim obj As T = Activator.CreateInstance(Of T)()
            Dim ms As New IO.MemoryStream(Encoding.Unicode.GetBytes(json))
            Dim serializer As New System.Runtime.Serialization.Json.DataContractJsonSerializer(obj.[GetType]())
            obj = DirectCast(serializer.ReadObject(ms), T)
            ms.Close()
            ms.Dispose()
            Return obj
        End Function

    End Class

End Namespace