﻿Imports System
Imports System.Data.Entity
Imports System.Data.Entity.Migrations
Imports System.Linq
Imports AppGestio.ModelLayer

Public Class MigrationInitial
    Public Shared Sub AddInitialDate(context As DataLayer.ServiceWCFContext)
        '  This method will be called after migrating to the latest version.

        context.ARTICLES.AddOrUpdate(Function(c) c.ArticleId,
                                     New Article With {.ArticleId = 0, .Nom = "Artícle Generic", .Preu = 0, .Unitats = ""},
                                     New Article With {.ArticleId = 1, .Nom = "Rajoles RX25 20cm x 20 cm", .Preu = 12.5, .Unitats = "m2"},
                                     New Article With {.ArticleId = 2, .Nom = "Sanefa RX25 7cm x 20 cm", .Preu = 6, .Unitats = "m"},
                                     New Article With {.ArticleId = 3, .Nom = "Pintura Anti-humitat", .Preu = 26, .Unitats = "m2"})

        context.CLIENTS.AddOrUpdate(Function(c) c.ClientId,
                                    New Client With {.ClientId = 1, .Nom = "Miguel López", .NIF = "458741235D",
                                                     .CP = 8020, .Direccio = "Carrer Balmes 251", .Poblacio = "Barcelona", .Provincia = "Barcelona",
                                                     .Telefon = "987547521", .Movil = "654214795", .Email = "miguell@mailproves.com", .Web = "www.webproves.com"},
                                    New Client With {.ClientId = 2, .Nom = "Maria Martí", .NIF = "987412541L",
                                        .CP = 8020, .Direccio = "Carrer Aribau 24", .Poblacio = "Barcelona", .Provincia = "Barcelona",
                                        .Telefon = "954217485", .Movil = "632587415", .Email = "mariam@mailproves.com", .Web = "www.webproves2.com"},
                                    New Client With {.ClientId = 3, .Nom = "Jose Delgado", .NIF = "14528974G",
                                        .CP = 8020, .Direccio = "Carrer Muntaner 54", .Poblacio = "Barcelona", .Provincia = "Barcelona",
                                        .Telefon = "954124785", .Movil = "632158741", .Email = "josed@mailproves.com", .Web = "www.webproves3.com"})

        Dim L1 As New List(Of PressupostLin)
        L1.Add(New PressupostLin With {.ArticleId = 1, .Descripcio = "Rajoles RX25 20cm x 20 cm",
                                                       .Linia = 1, .PercIVA = 21, .PressupostId = 1,
                                                       .Preu = 12.5, .Quantitat = 65, .Unitats = "m2"})

        L1.Add(New PressupostLin With {.ArticleId = 2, .Descripcio = "Sanefa RX25 7cm x 20 cm",
                                                       .Linia = 2, .PercIVA = 21, .PressupostId = 1,
                                                       .Preu = 6, .Quantitat = 7, .Unitats = "m"})

        Dim L2 As New List(Of PressupostLin)
        L2.Add(New PressupostLin With {.ArticleId = 3, .Descripcio = "Pintura Anti-humitat",
                                                       .Linia = 1, .PercIVA = 21, .PressupostId = 2,
                                                       .Preu = 26, .Quantitat = 35, .Unitats = "m2"})

        context.PRESSUPOSTOS.AddOrUpdate(Function(c) c.PressupostId,
                                    New Pressupost With {.PressupostId = 1, .Data = Now.AddDays(-15), .Descripcio = "Enrajolar paret de la cuina", .EstatPressupost = EnumEstatsPressupost.Generat,
                                                         .FormaPagament = EnumFormesPagament.Comptat, .NumVenciments = 1, .Observacions = "S'ha de fer avans de Febrer", .PercDescompte = 0, .Usuari = 1,
                                                         .ClientId = 1, .LiniesPressupost = L1},
                                    New Pressupost With {.PressupostId = 2, .Data = Now.AddDays(-2), .Descripcio = "Pintar despatx", .EstatPressupost = EnumEstatsPressupost.Acceptat,
                                                         .FormaPagament = EnumFormesPagament.Comptat, .NumVenciments = 1, .Observacions = "Fer 3 capes de pintura", .PercDescompte = 0, .Usuari = 1,
                                                         .ClientId = 1, .LiniesPressupost = L2})

        context.PROVEIDORS.AddOrUpdate(Function(c) c.ProveidorId,
                                    New Proveidor With {.ProveidorId = 1, .Nom = "Cerámicas Navarro S.L.", .NIF = "B65439825",
                                                     .CP = 8020, .Direccio = "Carrer Diputació 520", .Poblacio = "Barcelona", .Provincia = "Barcelona",
                                                     .Telefon = "954871235", .Movil = "657419852", .Email = "info@ceramicasnavarro.com", .Web = "www.ceramicasnavarro.com"},
                                    New Proveidor With {.ProveidorId = 2, .Nom = "Maxi Pinturas S.A.", .NIF = "A65945226",
                                        .CP = 8041, .Direccio = "Carrer Concell de Cent, 24", .Poblacio = "Barcelona", .Provincia = "Barcelona",
                                        .Telefon = "974132589", .Movil = "624852197", .Email = "vendes@maxipintures.com", .Web = "www.maxipintures.com"},
                                    New Proveidor With {.ProveidorId = 3, .Nom = "Ferretería Sants", .NIF = "B65407411",
                                        .CP = 8042, .Direccio = "Sants 120", .Poblacio = "Barcelona", .Provincia = "Barcelona",
                                        .Telefon = "954124785", .Movil = "632158741", .Email = "fersants@fersants.com", .Web = "www.webproves3.com"})
    End Sub
End Class
