﻿Imports System.Data.Entity
Imports AppGestio.ModelLayer
Imports AppGestio.DataLayer
Imports PagedList

Public Class ArticleController
    Inherits System.Web.Mvc.Controller

    '
    ' GET: /Article/

    Function Index(ByVal orden As String, ByVal filtroNombre As String, ByVal pagina As Integer?) As ActionResult
        ViewData("CurrentSort") = orden
        ViewData("IdSortParam") = If(String.IsNullOrEmpty(orden), "id_desc", "")
        ViewData("NomSortParam") = If(String.IsNullOrEmpty(orden), "nom_desc", "nom")

        Dim L As IEnumerable(Of ModelLayer.Article)

        If filtroNombre IsNot Nothing Then
            Session("CurrentFilter") = filtroNombre
            pagina = 1
        Else
            filtroNombre = If(Session("CurrentFilter") Is Nothing, "", Session("CurrentFilter").ToString)
        End If

        Try
            L = General.GetArticlesList(orden, filtroNombre)
        Catch ex As Exception
            L = New List(Of ModelLayer.Article)
        End Try

        Dim pageSize As Integer = 20
        Dim pageNumber As Integer = If(pagina Is Nothing, 1, pagina.Value)

        Return View(L.ToPagedList(pageNumber, pageSize))
    End Function

    '
    ' GET: /Article/Details/5

    Function Details(ByVal id As Integer?) As ActionResult
        If id Is Nothing Then
            Return New HttpStatusCodeResult(Net.HttpStatusCode.BadRequest)
        End If

        Dim A As ModelLayer.Article = General.GetArticleById(id.Value)
        If A IsNot Nothing Then
            Return View(A)
        Else
            Return HttpNotFound()
        End If
    End Function

    '
    ' GET: /Article/Create

    Function Create() As ActionResult
        Dim a As New ModelLayer.Article
        a.ArticleId = -1

        Return View(a)
    End Function

    '
    ' POST: /Article/Create

    <HttpPost()> _
    <ValidateAntiForgeryToken()> _
    Function Create(ByVal article As Article) As ActionResult

        Try
            If ModelState.IsValid Then
                General.Actualitza(article)
            Else
                Throw New Exception()
            End If


            ' TODO: Add insert logic here
            Return RedirectToAction("Index")
        Catch
            ModelState.AddModelError("", "No se pudo guardar el nuevo artículo.")
            Return View(article)
        End Try

    End Function

    '
    ' GET: /Article/Edit/5

    Function Edit(Optional ByVal id As Long = Nothing) As ActionResult
        Dim article As Article = General.GetArticleById(id)
        If IsNothing(article) Then
            Return HttpNotFound()
        End If
        Return View(article)
    End Function

    '
    ' POST: /Article/Edit/5

    <HttpPost()> _
    <ValidateAntiForgeryToken()> _
    Function Edit(ByVal article As Article) As ActionResult
        Try
            ' TODO: Add update logic here

            If ModelState.IsValid Then
                General.Actualitza(article)
            Else
                Throw New Exception()
            End If

            Return RedirectToAction("Index")
        Catch
            Return View()
        End Try
    End Function

    '
    ' GET: /Article/Delete/5

    Function Delete(Optional ByVal id As Long = Nothing) As ActionResult
        Dim article As Article = General.GetArticleById(id)
        If IsNothing(article) Then
            Return HttpNotFound()
        End If
        Return View(article)
    End Function

    '
    ' POST: /Article/Delete/5

    <HttpPost()> _
    <ActionName("Delete")> _
    <ValidateAntiForgeryToken()> _
    Function DeleteConfirmed(ByVal id As Long, ByVal submitButton As String) As RedirectToRouteResult
        If submitButton = Recursos.camps_eliminar Then
            General.EliminarArticle(id)
        End If

        Return RedirectToAction("Index")
    End Function

End Class