﻿Imports AppGestio
Imports PagedList

Public Class ClientController
    Inherits System.Web.Mvc.Controller

    '
    ' GET: /Client

    <Authorize>
    <InitializeSimpleMembership()> _
    Function Index(ByVal orden As String, ByVal filtroNombre As String, ByVal pagina As Integer?) As ActionResult

        ViewData("CurrentSort") = orden
        ViewData("IdSortParam") = If(String.IsNullOrEmpty(orden), "id_desc", "")
        ViewData("NomSortParam") = If(String.IsNullOrEmpty(orden), "nom_desc", "nom")
        ViewData("NifSortParam") = If(String.IsNullOrEmpty(orden), "nif_desc", "nif")
        Session("MENU") = AppGestio.EnumEstat.Clients

        Dim L As IEnumerable(Of ModelLayer.Client)

        If filtroNombre IsNot Nothing Then
            Session("CurrentFilter") = filtroNombre
            pagina = 1
        Else
            filtroNombre = If(Session("CurrentFilter") Is Nothing, "", Session("CurrentFilter").ToString)
        End If

        Try
            L = General.GetClientsList(orden, filtroNombre)
        Catch ex As Exception
            L = New List(Of ModelLayer.Client)
        End Try

        Dim pageSize As Integer = 20
        Dim pageNumber As Integer = If(pagina Is Nothing, 1, pagina.Value)

        Return View(L.ToPagedList(pageNumber, pageSize))
    End Function

    '
    ' GET: /Client/Details/5

    Function Details(ByVal id As Integer?) As ActionResult

        If id Is Nothing Then
            Return New HttpStatusCodeResult(Net.HttpStatusCode.BadRequest)
        End If

        Dim C As ModelLayer.Client = General.GetClientById(id.Value)
        If C IsNot Nothing Then
            Return View(C)
        Else
            Return HttpNotFound()
        End If

    End Function

    '
    ' GET: /Client/Create

    Function Create() As ActionResult

        Dim c As New ModelLayer.Client
        c.ClientId = -1

        Return View(c)
    End Function

    '
    ' POST: /Client/Create

    <HttpPost()> _
    Function Create(client As ModelLayer.Client) As ActionResult
        Try
            If ModelState.IsValid Then
                General.Actualitza(client)
            Else
                Throw New Exception()
            End If


            ' TODO: Add insert logic here
            Return RedirectToAction("Index")
        Catch
            ModelState.AddModelError("", "No se pudo guardar el nuevo cliente.")
            Return View(client)
        End Try
    End Function

    '
    ' GET: /Client/Edit/5

    Function Edit(ByVal id As Integer) As ActionResult
        Dim C As ModelLayer.Client = General.GetClientById(id)
        If C IsNot Nothing Then
            Return View(C)
        Else
            Return View(New ModelLayer.Client With {.ClientId = -1})
        End If
    End Function

    '
    ' POST: /Client/Edit/5

    <HttpPost()> _
    Function Edit(client As ModelLayer.Client) As ActionResult
        Try
            ' TODO: Add update logic here

            If ModelState.IsValid Then
                General.Actualitza(client)
            Else
                Throw New Exception()
            End If

            Return RedirectToAction("Index")
        Catch
            Return View(client)
        End Try
    End Function

    '
    ' GET: /Client/Delete/5

    Function Delete(ByVal id As Integer) As ActionResult
        Dim C As ModelLayer.Client = General.GetClientById(id)
        If IsNothing(C) Then
            Return HttpNotFound()
        End If
        Return View(C)
    End Function

    '
    ' POST: /Client/Delete/5

    <HttpPost()>
    <ActionName("Delete")>
    <ValidateAntiForgeryToken()>
    Function Delete(ByVal id As Integer, ByVal submitButton As String) As ActionResult
            If submitButton.Equals(Recursos.camps_eliminar) Then
                General.EliminarClient(id)
            End If

            Return RedirectToAction("Index")
    End Function
End Class