﻿Imports System.Data.Entity
Imports AppGestio.ModelLayer
Imports AppGestio.DataLayer

Public Class CobramentsController
    Inherits System.Web.Mvc.Controller

    Private db As New ServiceWCFContext

    '
    ' GET: /Cobraments/

    Function Index() As ActionResult
        Dim cobraments = db.COBRAMENTS.Include(Function(c) c.FacturaCli).Include(Function(c) c.Client)
        Return View(cobraments.ToList())
    End Function

    '
    ' GET: /Cobraments/Details/5

    Function Details(Optional ByVal id As Long = Nothing) As ActionResult
        Dim cobrament As Cobrament = db.COBRAMENTS.Find(id)
        If IsNothing(cobrament) Then
            Return HttpNotFound()
        End If
        Return View(cobrament)
    End Function

    '
    ' GET: /Cobraments/Create

    Function Create() As ActionResult
        ViewBag.FacturaCliId = New SelectList(db.FACTURES_CLI, "FacturaCliId", "Descripcio")
        ViewBag.ClientId = New SelectList(db.CLIENTS, "ClientId", "Nom")
        Return View()
    End Function

    '
    ' POST: /Cobraments/Create

    <HttpPost()> _
    <ValidateAntiForgeryToken()> _
    Function Create(ByVal cobrament As Cobrament) As ActionResult
        If ModelState.IsValid Then
            db.COBRAMENTS.Add(cobrament)
            db.SaveChanges()
            Return RedirectToAction("Index")
        End If

        ViewBag.FacturaCliId = New SelectList(db.FACTURES_CLI, "FacturaCliId", "Descripcio", cobrament.FacturaCliId)
        ViewBag.ClientId = New SelectList(db.CLIENTS, "ClientId", "Nom", cobrament.ClientId)
        Return View(cobrament)
    End Function

    '
    ' GET: /Cobraments/Edit/5

    Function Edit(Optional ByVal id As Long = Nothing) As ActionResult
        Dim cobrament As Cobrament = db.COBRAMENTS.Find(id)
        If IsNothing(cobrament) Then
            Return HttpNotFound()
        End If
        ViewBag.FacturaCliId = New SelectList(db.FACTURES_CLI, "FacturaCliId", "Descripcio", cobrament.FacturaCliId)
        ViewBag.ClientId = New SelectList(db.CLIENTS, "ClientId", "Nom", cobrament.ClientId)
        Return View(cobrament)
    End Function

    '
    ' POST: /Cobraments/Edit/5

    <HttpPost()> _
    <ValidateAntiForgeryToken()> _
    Function Edit(ByVal cobrament As Cobrament) As ActionResult
        If ModelState.IsValid Then
            db.Entry(cobrament).State = EntityState.Modified
            db.SaveChanges()
            Return RedirectToAction("Index")
        End If

        ViewBag.FacturaCliId = New SelectList(db.FACTURES_CLI, "FacturaCliId", "Descripcio", cobrament.FacturaCliId)
        ViewBag.ClientId = New SelectList(db.CLIENTS, "ClientId", "Nom", cobrament.ClientId)
        Return View(cobrament)
    End Function

    '
    ' GET: /Cobraments/Delete/5

    Function Delete(Optional ByVal id As Long = Nothing) As ActionResult
        Dim cobrament As Cobrament = db.COBRAMENTS.Find(id)
        If IsNothing(cobrament) Then
            Return HttpNotFound()
        End If
        Return View(cobrament)
    End Function

    '
    ' POST: /Cobraments/Delete/5

    <HttpPost()> _
    <ActionName("Delete")> _
    <ValidateAntiForgeryToken()> _
    Function DeleteConfirmed(ByVal id As Long) As RedirectToRouteResult
        Dim cobrament As Cobrament = db.COBRAMENTS.Find(id)
        db.COBRAMENTS.Remove(cobrament)
        db.SaveChanges()
        Return RedirectToAction("Index")
    End Function

    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        db.Dispose()
        MyBase.Dispose(disposing)
    End Sub

End Class