﻿Public Class EstadistiquesController
    Inherits System.Web.Mvc.Controller

    '
    ' GET: /Estadistiques

    Function Index() As ActionResult
        Session("MENU") = AppGestio.EnumEstat.Estadistiques
        Return View()
    End Function

    '
    ' GET: /Estadistiques/Balanc

    Function Balanc(Optional txtFechaIni As String = "", Optional txtFechaFin As String = "") As ActionResult

        If txtFechaIni = "" OrElse txtFechaFin = "" OrElse
            Not IsDate(txtFechaIni) OrElse Not IsDate(txtFechaFin) Then
            'S'empra per indicar a la vista si hi ha dades calculades.
            ViewBag.HasData = False
            Return View(New InformeBalanc)
        Else
            Dim fIni As Date = CDate(txtFechaIni)
            Dim fFin As Date = CDate(txtFechaFin)
            Dim d As InformeBalanc = General.GetDadessBalanc(fIni, fFin)
            'S'empra per indicar a la vista si hi ha dades calculades.
            ViewBag.HasData = True
            Return View(d)
        End If

    End Function


    '
    ' GET: /Estadistiques/LlibreIva

    Function LlibreIva(Optional txtFechaIni As String = "", Optional txtFechaFin As String = "") As ActionResult

        If txtFechaIni = "" OrElse txtFechaFin = "" OrElse
            Not IsDate(txtFechaIni) OrElse Not IsDate(txtFechaFin) Then
            ViewBag.HasData = False
            Return View(New List(Of InformeLlibreIVA))
        Else
            Dim fIni As Date = CDate(txtFechaIni)
            Dim fFin As Date = CDate(txtFechaFin)
            Dim d As List(Of InformeLlibreIVA) = General.GetDadessLlibreIva(fIni, fFin)
            ViewBag.HasData = True
            Return View(d)
        End If

    End Function

    '
    ' GET: /Estadistiques/Facturacio

    Function Facturacio(Optional txtFechaIni As String = "", Optional txtFechaFin As String = "") As ActionResult

        If txtFechaIni = "" OrElse txtFechaFin = "" OrElse
            Not IsDate(txtFechaIni) OrElse Not IsDate(txtFechaFin) Then
            ViewBag.HasData = False
            Return View(New List(Of InformeEstadistFact))
        Else
            Dim fIni As Date = CDate(txtFechaIni)
            Dim fFin As Date = CDate(txtFechaFin)
            Dim d As List(Of InformeEstadistFact) = General.GetDadesFacturacio(fIni, fFin)
            ViewBag.HasData = True
            Return View(d)
        End If

    End Function
End Class