﻿Imports System.Data.Entity
Imports AppGestio.ModelLayer
Imports AppGestio.DataLayer

Public Class FacturaCliController
    Inherits System.Web.Mvc.Controller
    '
    ' GET: /FacturaCli/

    Function Index(Optional txtFechaIni As String = "", Optional txtFechaFin As String = "") As ActionResult
        Return LlistaEntreDates(txtFechaIni, txtFechaFin)
    End Function

    '
    ' GET: /FacturaCli/Details/5

    Function Details(ByVal id As Long?) As ActionResult
        If id Is Nothing Then
            Return New HttpStatusCodeResult(Net.HttpStatusCode.BadRequest)
        End If

        Dim C As ModelLayer.FacturaCli = General.GetFacturaCliById(id.Value)
        If C IsNot Nothing Then
            Return View(C)
        Else
            Return HttpNotFound()
        End If
    End Function

    '
    ' POST: /FacturaCli/Details/5

    <HttpPost()>
    <ValidateAntiForgeryToken()>
    Function Details(ByVal id As Integer, ByVal boton As String) As ActionResult
        If boton.Equals(Recursos.camps_eliminar) Then
            General.EliminarFactura(id)
            Return RedirectToAction("Index")
        ElseIf boton.Equals(Recursos.button_anular) Then
            Dim F As ModelLayer.FacturaCli = General.AnularFacturaClient(id)
            Return View(F)
        ElseIf boton.Equals(Recursos.button_acceptar) Then
            Dim F As ModelLayer.FacturaCli = General.AcceptarFacturaClient(id)
            Return View(F)
        ElseIf boton.Equals(Recursos.button_facturar) Then
            Dim F As ModelLayer.FacturaCli = General.FacturarFacturaClient(id)
            Return View(F)
        Else
            Dim F As ModelLayer.FacturaCli = General.GetFacturaCliById(id)
            Return View(F)
        End If
    End Function



    'Function Acceptar(id As Integer) As ActionResult
    '    Try
    '        Dim F As ModelLayer.FacturaCli = General.AcceptarFacturaClient(id)
    '    Catch ex As Exception
    '    End Try

    '    Return RedirectToAction("Index")
    'End Function

    'Function Anular(id As Integer) As ActionResult
    '    Try
    '        Dim F As ModelLayer.FacturaCli = General.AnularFacturaClient(id)
    '    Catch ex As Exception
    '    End Try

    '    Return RedirectToAction("Index")
    'End Function

    'Function Facturar(id As Integer) As ActionResult
    '    Try
    '        Dim F As ModelLayer.FacturaCli = General.FacturarFacturaClient(id)
    '    Catch ex As Exception
    '    End Try

    '    Return RedirectToAction("Index")
    'End Function

    '
    ' GET: /FacturaCli/Edit/5

    Function Edit(ByVal id As Long) As ActionResult
        Dim C As ModelLayer.FacturaCli = General.GetFacturaCliById(id)
        If C IsNot Nothing Then
            ViewData("clients") = General.GetClientsList("nom", "")
            Return View(C)
        Else
            Return HttpNotFound()
        End If
    End Function

    '
    ' POST: /FacturaCli/Edit/5

    <HttpPost()> _
    <ValidateAntiForgeryToken()> _
    Function Edit(ByVal facturacli As FacturaCli) As ActionResult
        Try
            ' TODO: Add update logic here

            If ModelState.IsValid Then
                General.Actualitza(facturacli)
            Else
                Throw New Exception()
            End If

            Return RedirectToAction("Index")
        Catch
            Return View(facturacli)
        End Try

    End Function

    '
    ' GET: /FacturaCli/Delete/5

    Function Delete(Optional ByVal id As Long = Nothing) As ActionResult
        Dim F As ModelLayer.FacturaCli = General.GetFacturaCliById(id)
        If IsNothing(F) Then
            Return HttpNotFound()
        End If
        Return View(F)
    End Function

    '
    ' POST: /FacturaCli/Delete/5

    <HttpPost()> _
    <ActionName("Delete")> _
    <ValidateAntiForgeryToken()> _
    Function DeleteConfirmed(ByVal id As Integer, ByVal submitButton As String) As ActionResult
        If submitButton.Equals(Recursos.camps_eliminar) Then
            General.EliminarFactura(id)
        End If

        Return RedirectToAction("Index")
    End Function

    '
    ' GET: /FacturaCli/Acceptar/5

    Function Acceptar(ByVal id As Long?) As ActionResult
        Dim F As ModelLayer.FacturaCli
        Try
            F = General.AcceptarFacturaClient(CInt(id))
        Catch ex As Exception
            ModelState.AddModelError("", ex.Message)
        End Try

        If IsNothing(F) Then
            ModelState.AddModelError("", Recursos.err_desconocido)
        End If
        Return RedirectToAction("Index")
    End Function

    '
    ' GET: /FacturaCli/Anular/5

    Function Anular(ByVal id As Long?) As ActionResult
        Dim F As ModelLayer.FacturaCli
        Try
            F = General.AnularFacturaClient(CInt(id))
        Catch ex As Exception
            ModelState.AddModelError("", ex.Message)
        End Try

        If IsNothing(F) Then
            ModelState.AddModelError("", Recursos.err_desconocido)
        End If

        Return RedirectToAction("Index")

    End Function

    '
    ' GET: /FacturaCli/Facturar/5

    Function Facturar(ByVal id As Long?) As ActionResult
        Dim F As ModelLayer.FacturaCli
        Try
            F = General.FacturarFacturaClient(CInt(id))
        Catch ex As Exception
            ModelState.AddModelError("", ex.Message)
        End Try

        If IsNothing(F) Then
            ModelState.AddModelError("", Recursos.err_desconocido)

        End If
        Return RedirectToAction("Index")
    End Function

#Region "Funcions privades"
    Private Function LlistaEntreDates(ByVal DataIni As String, ByVal DataFi As String) As ActionResult
        Dim L As IEnumerable(Of ModelLayer.FacturaCli)
        Dim fIni As Date
        Dim fFin As Date

        If DataIni = "" OrElse Not IsDate(DataIni) Then
            fIni = Now.AddMonths(-1)
        Else
            fIni = CDate(DataIni)
        End If

        If DataFi = "" OrElse Not IsDate(DataFi) Then
            fFin = Now
        Else
            fFin = CDate(DataFi)
        End If

        Try
            L = General.GetfacturesList(fIni, fFin)
        Catch ex As Exception
            L = New List(Of ModelLayer.FacturaCli)
        End Try

        Return View("Index", L)
    End Function
#End Region

End Class