﻿Imports System.Data.Entity
Imports AppGestio.ModelLayer
Imports AppGestio.DataLayer

Public Class FacturaProController
    Inherits System.Web.Mvc.Controller



    '
    ' GET: /FacturaPro/

    Function Index(Optional txtFechaIni As String = "", Optional txtFechaFin As String = "") As ActionResult
        Dim L As List(Of ModelLayer.FacturaPro)
        Dim fIni As Date
        Dim fFin As Date

        If txtFechaIni = "" OrElse Not IsDate(txtFechaIni) Then
            fIni = Now.AddMonths(-1)
        Else
            fIni = CDate(txtFechaIni)
        End If

        If txtFechaFin = "" OrElse Not IsDate(txtFechaFin) Then
            fFin = Now.AddDays(1)
        Else
            fFin = CDate(txtFechaFin)
        End If

        Try
            L = General.GetfacturesProList(fIni, fFin)
        Catch ex As Exception
            L = New List(Of ModelLayer.FacturaPro)
        End Try

        Return View(L)
    End Function

    '
    ' GET: /FacturaPro/Details/5

    Function Details(ByVal id As Long) As ActionResult
        Dim F As FacturaPro = General.GetFacturaProById(id)

        If F.LiniesFactura Is Nothing Then
            F.LiniesFactura = New List(Of FacturaProLin)
        End If

        If F IsNot Nothing Then
            Session("currFacPro") = F.FacturaProId
            ViewData("proveidors") = General.GetProveidorList("nom", "")
            Return View(F)
        Else
            Return HttpNotFound()
        End If
    End Function


    '
    ' POST: /FacturaPro/Details/5

    <HttpPost()> _
    Function Details(P As ModelLayer.FacturaPro, boton As String, ByVal collection As FormCollection) As ActionResult
        Try

            Dim press As Long = CLng(Session("currFacPro"))
            P = General.GetFacturaProById(press)

            If boton.Equals(Recursos.button_facturar) Then

                If P IsNot Nothing Then
                    General.Actualitza(P)
                    P = General.FacturarFacturaPro(press)
                End If

            ElseIf boton.Equals(Recursos.button_anular) Then
                If P IsNot Nothing Then
                    General.Actualitza(P)
                    P = General.AnularFacturaPro(press)
                End If
            End If
        Catch
        End Try

        Session("currFacPro") = P.FacturaProId
        ViewData("proveidors") = General.GetProveidorList("nom", "")
        Return View(P)
    End Function

    '
    ' GET: /FacturaPro/Create

    Function Create() As ActionResult

        Dim F As New ModelLayer.FacturaPro
        F.FacturaProId = -1
        F.EstatFactura = EnumEstatsFacturaPro.Generada
        F.Data = Now

        General.Actualitza(F)

        Return RedirectToAction("Edit", New With {.id = F.FacturaProId})

    End Function

#Region "JSon"
    <HttpGet>
    Function UpdateRecord(Linia As Byte, Desc As String,
                          Quantitat As Single, preu As Double, PercIva As Single) As JsonResult

        Dim result As Boolean = False

        Try
            Dim press As Long = CLng(Session("currFacPro"))


            result = General.Actualitza(New ModelLayer.FacturaProLin With {.FacturaProId = press,
                                                                            .Linia = Linia,
                                                                            .Descripcio = Desc,
                                                                            .Quantitat = Quantitat,
                                                                            .Preu = preu,
                                                                            .PercIVA = PercIva})
        Catch ex As Exception

        End Try

        Return Json(New With {result}, JsonRequestBehavior.AllowGet)

    End Function

    <HttpGet>
    Function DeleteRecord(Linia As Byte) As JsonResult
        Dim result As Boolean = False

        Try
            Dim press As Long = CLng(Session("currFacPro"))


            result = General.EliminarLiniaFacturaPro(press, Linia)
        Catch ex As Exception
        End Try

        Return Json(New With {result}, JsonRequestBehavior.AllowGet)

    End Function
#End Region

    Function Edit(ByVal id As Integer?) As ActionResult
        If Not id.HasValue Then
            If Session("currFacPro") Is Nothing OrElse Not IsNumeric(Session("currFacPro")) Then
                Return HttpNotFound()
            Else
                id = CInt(Session("currFacPro"))
            End If
        End If

        Dim P As ModelLayer.FacturaPro = General.GetFacturaProById(id.Value)
        If P IsNot Nothing Then
            If P.EstatFactura <> EnumEstatsFacturaPro.Generada Then
                Return RedirectToAction("Details", New With {.id = P.FacturaProId})
            End If
            Session("currFacPro") = P.FacturaProId
            ViewData("proveidors") = General.GetProveidorList("nom", "")
            Return View(P)
        Else
            Return HttpNotFound()
        End If

    End Function

    '
    ' POST: /FacturaPro/Edit/5

    <HttpPost()> _
    <ValidateAntiForgeryToken()> _
    Function Edit(P As ModelLayer.FacturaPro, boton As String, ByVal collection As FormCollection) As ActionResult
        Try

            Dim press As Long = CLng(Session("currFacPro"))
            P.FacturaProId = press

            If boton.Equals(Recursos.button_guardar) Then

                If P IsNot Nothing Then
                    General.Actualitza(P)
                End If
                Return RedirectToAction("Index")

            ElseIf boton.Equals(Recursos.button_facturar) Then
                If P IsNot Nothing Then
                    General.Actualitza(P)
                    Dim F As ModelLayer.FacturaPro = General.FacturarFacturaPro(CInt(P.FacturaProId))
                    Return RedirectToAction("Details", "FacturaPro", New With {.id = P.FacturaProId})
                End If
                Return View(P)
            End If

        Catch
        End Try

        Session("currFacPro") = P.FacturaProId
        ViewData("proveidors") = General.GetProveidorList("nom", "")
        Return View(P)

    End Function

    '
    ' GET: /FacturaPro/Delete/5

    Function Delete(Optional ByVal id As Long = Nothing) As ActionResult
        Dim P As ModelLayer.FacturaPro = General.GetFacturaProById(id)
        If IsNothing(P) Then
            Return HttpNotFound()
        End If
        Return View(P)
    End Function

    '
    ' POST: /FacturaPro/Delete/5

    <HttpPost()> _
    <ActionName("Delete")> _
    <ValidateAntiForgeryToken()> _
    Function DeleteConfirmed(ByVal id As Long) As RedirectToRouteResult
        
        General.EliminarFacturaPro(id)

        Return RedirectToAction("Index")
    End Function


    '
    ' GET: /FacturaPro/LlegirPendents

    Function LlegirPendents() As ActionResult

        'Es genera un context nou per estar segurs que llegeix les dades noves, no les que te en memoria.
        Dim db As New DataLayer.ServiceWCFContext
        Return View(db.DOCUMENTS.Where(Function(d) d.Estat = EnumEstatsDocument.Pendent))

    End Function


    Function DownloadFile(ByVal id As Long) As ActionResult

        Dim b() As Byte = Nothing
        Dim tipus As String = ""

        If General.ObtenirDadesFile(id, b, tipus) Then
            Return File(b, tipus)
        Else
            Return RedirectToAction("Index")
        End If

    End Function

    Function AcceptarFile(ByVal id As Long) As ActionResult

        Dim F As FacturaPro = General.AcceptarFile(id)

        If F IsNot Nothing Then
            Return RedirectToAction("Edit", "FacturaPro", New With {.id = F.FacturaProId})
        Else
            Return RedirectToAction("LlegirPendents")
        End If


    End Function


    '
    ' GET: /FacturaPro/DenegarFile/5

    Function DenegarFile(ByVal id As Long) As ActionResult

        Dim dfm As New DenegarFileModel
        dfm.Id = id
        dfm.EnviarMail = False
        dfm.Comentario = ""

        Return View(dfm)
    End Function

    '
    ' Post: /FacturaPro/DenegarFile/5

    <HttpPost>
    Function DenegarFile(ByVal dfm As DenegarFileModel) As ActionResult

        General.DenegarFile(dfm.Id, dfm.Comentario, dfm.EnviarMail)

        
        Return RedirectToAction("LlegirPendents")


    End Function

End Class