﻿Imports System.Data.Entity
Imports AppGestio.ModelLayer
Imports AppGestio.DataLayer

Public Class PagamentsController
    Inherits System.Web.Mvc.Controller

    Private db As New ServiceWCFContext

    '
    ' GET: /Pagaments/

    Function Index() As ActionResult
        Dim pagaments = db.PAGAMENTS.Include(Function(p) p.FacturaPro).Include(Function(p) p.Proveidor)
        Return View(pagaments.ToList())
    End Function

    '
    ' GET: /Pagaments/Details/5

    Function Details(Optional ByVal id As Long = Nothing) As ActionResult
        Dim pagament As Pagament = db.PAGAMENTS.Find(id)
        If IsNothing(pagament) Then
            Return HttpNotFound()
        End If
        Return View(pagament)
    End Function

    '
    ' GET: /Pagaments/Create

    Function Create() As ActionResult
        ViewBag.FacturaProId = New SelectList(db.FACTURES_PRO, "FacturaProId", "Descripcio")
        ViewBag.ProveidorId = New SelectList(db.PROVEIDORS, "ProveidorId", "NomContacte")
        Return View()
    End Function

    '
    ' POST: /Pagaments/Create

    <HttpPost()> _
    <ValidateAntiForgeryToken()> _
    Function Create(ByVal pagament As Pagament) As ActionResult
        If ModelState.IsValid Then
            db.PAGAMENTS.Add(pagament)
            db.SaveChanges()
            Return RedirectToAction("Index")
        End If

        ViewBag.FacturaProId = New SelectList(db.FACTURES_PRO, "FacturaProId", "Descripcio", pagament.FacturaProId)
        ViewBag.ProveidorId = New SelectList(db.PROVEIDORS, "ProveidorId", "NomContacte", pagament.ProveidorId)
        Return View(pagament)
    End Function

    '
    ' GET: /Pagaments/Edit/5

    Function Edit(Optional ByVal id As Long = Nothing) As ActionResult
        Dim pagament As Pagament = db.PAGAMENTS.Find(id)
        If IsNothing(pagament) Then
            Return HttpNotFound()
        End If
        ViewBag.FacturaProId = New SelectList(db.FACTURES_PRO, "FacturaProId", "Descripcio", pagament.FacturaProId)
        ViewBag.ProveidorId = New SelectList(db.PROVEIDORS, "ProveidorId", "NomContacte", pagament.ProveidorId)
        Return View(pagament)
    End Function

    '
    ' POST: /Pagaments/Edit/5

    <HttpPost()> _
    <ValidateAntiForgeryToken()> _
    Function Edit(ByVal pagament As Pagament) As ActionResult
        If ModelState.IsValid Then
            db.Entry(pagament).State = EntityState.Modified
            db.SaveChanges()
            Return RedirectToAction("Index")
        End If

        ViewBag.FacturaProId = New SelectList(db.FACTURES_PRO, "FacturaProId", "Descripcio", pagament.FacturaProId)
        ViewBag.ProveidorId = New SelectList(db.PROVEIDORS, "ProveidorId", "NomContacte", pagament.ProveidorId)
        Return View(pagament)
    End Function

    '
    ' GET: /Pagaments/Delete/5

    Function Delete(Optional ByVal id As Long = Nothing) As ActionResult
        Dim pagament As Pagament = db.PAGAMENTS.Find(id)
        If IsNothing(pagament) Then
            Return HttpNotFound()
        End If
        Return View(pagament)
    End Function

    '
    ' POST: /Pagaments/Delete/5

    <HttpPost()> _
    <ActionName("Delete")> _
    <ValidateAntiForgeryToken()> _
    Function DeleteConfirmed(ByVal id As Long) As RedirectToRouteResult
        Dim pagament As Pagament = db.PAGAMENTS.Find(id)
        db.PAGAMENTS.Remove(pagament)
        db.SaveChanges()
        Return RedirectToAction("Index")
    End Function

    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        db.Dispose()
        MyBase.Dispose(disposing)
    End Sub

End Class