﻿
Public Class PressupostosController
    Inherits System.Web.Mvc.Controller

    '
    ' GET: /Pressupostos

    Function Index(Optional txtFechaIni As String = "", Optional txtFechaFin As String = "") As ActionResult

        Dim L As IEnumerable(Of ModelLayer.Pressupost)
        Dim fIni As Date
        Dim fFin As Date

        If txtFechaIni = "" OrElse Not IsDate(txtFechaIni) Then
            fIni = Now.AddMonths(-1)
        Else
            fIni = CDate(txtFechaIni)
        End If

        If txtFechaFin = "" OrElse Not IsDate(txtFechaFin) Then
            fFin = Now.AddDays(1)
        Else
            fFin = CDate(txtFechaFin)
        End If

        Try
            L = General.GetpressupostosList(fIni, fFin)
        Catch ex As Exception
            L = New List(Of ModelLayer.Pressupost)
        End Try

        Return View(L)
    End Function

    '
    ' GET: /Pressupostos/Details/5

    Function Details(ByVal id As Integer) As ActionResult
        Dim P As ModelLayer.Pressupost = General.GetPressupostById(id)
        If P IsNot Nothing Then
            Session("currPressup") = P.PressupostId
            Return View(P)
        Else
            Return HttpNotFound()
        End If
    End Function

    '
    ' POST: /Pressupostos/Details/5

    <HttpPost()> _
    Function Details(P As ModelLayer.Pressupost, boton As String, ByVal collection As FormCollection) As ActionResult
        Try

            Dim press As Long = CLng(Session("currPressup"))
            P = General.GetPressupostById(press)

            If boton.Equals(Recursos.msg_gotofactura) Then

                If P IsNot Nothing Then
                    If P.FacturaCli IsNot Nothing Then
                        Return RedirectToAction("Details", "FacturaCli", New With {.id = P.FacturaCli.FacturaCliId})
                    End If
                End If

            ElseIf boton.Equals(Recursos.button_anular) Then
                If P IsNot Nothing Then
                    General.Actualitza(P)
                End If
            End If
        Catch
        End Try

        Session("currPressup") = P.PressupostId
        ViewData("clients") = General.GetClientsList("nom", "")
        ViewData("articles") = General.GetArticlesList("Nom", "")
        Return View(P)
    End Function


    '
    ' GET: /Pressupostos/Create

    Function Create() As ActionResult

        Dim P As New ModelLayer.Pressupost
        P.PressupostId = -1
        P.EstatPressupost = EnumEstatsPressupost.Generat
        P.Data = Now

        General.Actualitza(P)

        Return RedirectToAction("Edit", New With {.id = P.PressupostId})

    End Function

    ''
    '' POST: /Pressupostos/Create

    '<HttpPost()> _
    'Function Create(P As ModelLayer.Pressupost, boton As String, ByVal collection As FormCollection) As ActionResult
    '    Try


    '        If boton.Equals(Recursos.button_guardar) Then

    '            If P IsNot Nothing Then
    '                General.Actualitza(P)
    '            End If
    '            Return RedirectToAction("Index")

    '        ElseIf boton.Equals(Recursos.button_aplicar) Then
    '            If P IsNot Nothing Then
    '                General.Actualitza(P)
    '            End If
    '            'ElseIf boton.Equals(Recursos.button_addLinea) Then
    '            '    ' Añadir una linea
    '            '    General.PressupostAddLinea(P)
    '        End If



    '    Catch
    '    End Try

    '    ViewData("clients") = General.GetClientsList("nom", "")
    '    Return View(P)
    'End Function

    ''
    '' GET: /Pressupostos/AddLine

    'Function AddLine(P As ModelLayer.Pressupost) As ActionResult

    '    Dim xLin As Integer = 1
    '    If P Is Nothing Then
    '        P = New ModelLayer.Pressupost
    '    End If
    '    If P.LiniesPressupost Is Nothing Then
    '        P.LiniesPressupost = New List(Of ModelLayer.PressupostLin)
    '    Else
    '        xLin = (From x As ModelLayer.PressupostLin In P.LiniesPressupost Select x.Linia).Max + 1
    '    End If

    '    P.LiniesPressupost.Add(New ModelLayer.PressupostLin With {.Linia = xLin,
    '                           .PressupostId = P.PressupostId,
    '                           .Pressupost = P,
    '                           .Quantitat = 1,
    '                           .Preu = 0})

    '    Return View(P)
    'End Function

    '
    ' POST: /Pressupostos/Create

    '<HttpPost()> _
    '<ActionName("AddLine")> _
    'Function AddLineConfirmed(P As ModelLayer.Pressupost) As ActionResult
    '    Try
    '        ' TODO: Add insert logic here
    '        Return RedirectToAction("Index")
    '    Catch
    '        Return View()
    '    End Try
    'End Function

#Region "JSon"
    <HttpGet>
    Function UpdateRecord(Linia As Byte, Desc As String,
                          Quantitat As Single, preu As Double, PercIva As Single) As JsonResult

        Dim result As Boolean = False

        Try
            Dim press As Long = CLng(Session("currPressup"))


            result = General.Actualitza(New ModelLayer.PressupostLin With {.PressupostId = press,
                                                                                                  .Linia = Linia,
                                                                                                  .Descripcio = Desc,
                                                                                                  .Quantitat = Quantitat,
                                                                                                  .Preu = preu,
                                                                                                  .PercIVA = PercIva})
        Catch ex As Exception

        End Try

        Return Json(New With {result}, JsonRequestBehavior.AllowGet)

    End Function

    <HttpGet>
    Function DeleteRecord(Linia As Byte) As JsonResult
        Dim result As Boolean = False

        Try
            Dim press As Long = CLng(Session("currPressup"))


            result = General.EliminarLiniaPresupost(press, Linia)
        Catch ex As Exception
        End Try

        Return Json(New With {result}, JsonRequestBehavior.AllowGet)

    End Function
#End Region


    '
    ' GET: /Pressupostos/Edit/5

    Function Edit(ByVal id As Integer?) As ActionResult
        If Not id.HasValue Then
            If Session("currPressup") Is Nothing OrElse Not IsNumeric(Session("currPressup")) Then
                Return HttpNotFound()
            Else
                id = CInt(Session("currPressup"))
            End If
        End If

        Dim P As ModelLayer.Pressupost = General.GetPressupostById(id.Value)
        If P IsNot Nothing Then
            If P.EstatPressupost <> EnumEstatsPressupost.Generat Then
                Return RedirectToAction("Details", New With {.id = P.PressupostId})
            End If
            Session("currPressup") = P.PressupostId
            ViewData("clients") = General.GetClientsList("nom", "")
            ViewData("articles") = General.GetArticlesList("Nom", "")
            Return View(P)
        Else
            Return HttpNotFound()
        End If
    End Function

    '
    ' POST: /Pressupostos/Edit/5

    <HttpPost()> _
    Function Edit(P As ModelLayer.Pressupost, boton As String, ByVal collection As FormCollection) As ActionResult
        Try

            Dim press As Long = CLng(Session("currPressup"))
            P.PressupostId = press

            If boton.Equals(Recursos.button_guardar) Then

                If P IsNot Nothing Then
                    General.Actualitza(P)
                End If
                Return RedirectToAction("Index")

            ElseIf boton.Equals(Recursos.button_aplicar) Then
                If P IsNot Nothing Then
                    General.Actualitza(P)
                End If
            ElseIf boton.Equals(Recursos.button_acceptar) Then
                If P IsNot Nothing Then
                    General.Actualitza(P)
                    Dim F As ModelLayer.FacturaCli = General.AcceptarPressupost(CInt(P.PressupostId))
                    Return RedirectToAction("Details", "FacturaCli", New With {.id = F.FacturaCliId})
                End If
                Return View(P)
                'ElseIf boton.Equals(Recursos.button_addLinea) Then
                '    ' Añadir una linea
                '    General.PressupostAddLinea(P)
                '    ViewData("clients") = General.GetClientsList("nom", "")
                '    ViewData("articles") = General.GetArticlesList("Nom", "")
                '    Return View(P)
            End If

        Catch
        End Try

        Session("currPressup") = P.PressupostId
        ViewData("clients") = General.GetClientsList("nom", "")
        Return View(P)
    End Function

    '
    ' GET: /Pressupostos/Delete/5

    Function Delete(ByVal id As Integer) As ActionResult
        Dim P As ModelLayer.Pressupost = General.GetPressupostById(id)
        If IsNothing(P) Then
            Return HttpNotFound()
        End If
        Return View(P)
    End Function

    '
    ' POST: /Pressupostos/Delete/5

    <HttpPost()>
    <ActionName("Delete")>
    <ValidateAntiForgeryToken()>
    Function Delete(ByVal id As Integer, ByVal submitButton As String) As ActionResult
        'If submitButton.Equals(Recursos.camps_eliminar) Then
        General.EliminarPressupost(id)
        'End If

        Return RedirectToAction("Index")
    End Function
End Class