﻿Imports System.Data.Entity
Imports AppGestio.ModelLayer
Imports AppGestio.DataLayer
Imports PagedList

Public Class ProveedorController
    Inherits System.Web.Mvc.Controller

    '
    ' GET: /Proveedor/

    Function Index(ByVal orden As String, ByVal filtroNombre As String, ByVal pagina As Integer?) As ActionResult
        ViewData("CurrentSort") = orden
        ViewData("IdSortParam") = If(String.IsNullOrEmpty(orden), "id_desc", "")
        ViewData("NomSortParam") = If(String.IsNullOrEmpty(orden), "nom_desc", "nom")
        ViewData("NifSortParam") = If(String.IsNullOrEmpty(orden), "nif_desc", "nif")
        Session("MENU") = AppGestio.EnumEstat.Proveidors

        Dim L As IEnumerable(Of ModelLayer.Proveidor)

        If filtroNombre IsNot Nothing Then
            Session("CurrentFilter") = filtroNombre
            pagina = 1
        Else
            filtroNombre = If(Session("CurrentFilter") Is Nothing, "", Session("CurrentFilter").ToString)
        End If

        Try
            L = General.GetProveidorList(orden, filtroNombre)
        Catch ex As Exception
            L = New List(Of ModelLayer.Proveidor)
        End Try

        Dim pageSize As Integer = 20
        Dim pageNumber As Integer = If(pagina Is Nothing, 1, pagina.Value)

        Return View(L.ToPagedList(pageNumber, pageSize))


    End Function

    '
    ' GET: /Proveedor/Details/5

    Function Details(ByVal id As Integer?) As ActionResult

        If id Is Nothing Then
            Return New HttpStatusCodeResult(Net.HttpStatusCode.BadRequest)
        End If

        Dim P As Proveidor = General.GetProveidorById(id.Value)
        If P IsNot Nothing Then
            Return View(P)
        Else
            Return HttpNotFound()
        End If

    End Function

    '
    ' GET: /Proveedor/Create

    Function Create() As ActionResult
        Dim P As New ModelLayer.Proveidor
        P.ProveidorId = -1



        Return View(P)
    End Function

    '
    ' POST: /Proveedor/Create

    <HttpPost()> _
    <ValidateAntiForgeryToken()> _
    Function Create(ByVal proveidor As Proveidor) As ActionResult
        Try
            If ModelState.IsValid Then
                General.Actualitza(proveidor)
            Else
                Throw New Exception()
            End If


            ' TODO: Add insert logic here
            Return RedirectToAction("Index")
        Catch
            ModelState.AddModelError("", "No se pudo guardar el nuevo cliente.")
            Return View(proveidor)
        End Try
    End Function

    '
    ' GET: /Proveedor/Edit/5

    Function Edit(Optional ByVal id As Long = Nothing) As ActionResult

        Dim P As ModelLayer.Proveidor = General.GetProveidorById(id)
        If P IsNot Nothing Then
            Return View(P)
        Else
            Return View(New ModelLayer.Proveidor With {.ProveidorId = -1})
        End If
    End Function

    '
    ' POST: /Proveedor/Edit/5

    <HttpPost()> _
    <ValidateAntiForgeryToken()> _
    Function Edit(ByVal proveidor As Proveidor) As ActionResult
        Try

            If ModelState.IsValid Then
                General.Actualitza(proveidor)
            Else
                Throw New Exception()
            End If

            Return RedirectToAction("Index")
        Catch
            Return View()
        End Try
    End Function

    '
    ' GET: /Proveedor/Delete/5

    Function Delete(Optional ByVal id As Long = Nothing) As ActionResult
        Dim proveidor As Proveidor = General.GetProveidorById(id)
        If IsNothing(proveidor) Then
            Return HttpNotFound()
        End If
        Return View(proveidor)
    End Function

    '
    ' POST: /Proveedor/Delete/5

    <HttpPost()> _
    <ActionName("Delete")> _
    <ValidateAntiForgeryToken()> _
    Function DeleteConfirmed(ByVal id As Integer, ByVal submitButton As String) As RedirectToRouteResult

        If submitButton.Equals(Recursos.camps_eliminar) Then
            General.EliminarPRoveidor(id)            
        End If

        Return RedirectToAction("Index")

    End Function


End Class