Imports System
Imports System.Data.Entity.Migrations

Namespace Migrations
    Public Partial Class Initial
        Inherits DbMigration
    
        Public Overrides Sub Up()
            CreateTable(
                "dbo.USUARIS",
                Function(c) New With
                    {
                        .UsuariId = c.Int(nullable := False, identity := True),
                        .NomUsuari = c.String(),
                        .NomComplet = c.String(),
                        .Contrassenya = c.String(),
                        .Tipus = c.Int(),
                        .DataAlta = c.DateTime(),
                        .Estat = c.Int(),
                        .DataBaixa = c.DateTime(),
                        .DataUltimAcces = c.DateTime(),
                        .Nom = c.String(),
                        .AccesClients = c.Boolean(),
                        .AccesProveidors = c.Boolean(),
                        .AccesPressupostos = c.Boolean(),
                        .AccesPresupostos = c.Boolean(),
                        .AccesFacturesCli = c.Boolean(),
                        .AccesFacturesPro = c.Boolean(),
                        .AccesFacturesDes = c.Boolean(),
                        .AccesCobraments = c.Boolean(),
                        .AccesPagaments = c.Boolean(),
                        .AccesContabilitat = c.Boolean(),
                        .AccesWindowsPhone = c.Boolean()
                    }) _
                .PrimaryKey(Function(t) t.UsuariId)
            
            CreateTable(
                "dbo.CLIENTS",
                Function(c) New With
                    {
                        .ClientId = c.Long(nullable := False, identity := True),
                        .Nom = c.String(),
                        .NIF = c.String(),
                        .Direccio = c.String(),
                        .CP = c.Int(nullable := False),
                        .Poblacio = c.String(),
                        .Provincia = c.String(),
                        .Pais = c.String(),
                        .Telefon = c.String(),
                        .Movil = c.String(),
                        .Email = c.String(),
                        .Web = c.String()
                    }) _
                .PrimaryKey(Function(t) t.ClientId)
            
            CreateTable(
                "dbo.PRESSUPOSTOS",
                Function(c) New With
                    {
                        .PressupostId = c.Long(nullable:=False),
                        .ClientId = c.Long(nullable:=False),
                        .EstatPressupost = c.Int(nullable:=False),
                        .Descripcio = c.String(),
                        .Data = c.DateTime(nullable:=False),
                        .Usuari = c.Int(nullable:=False),
                        .PercDescompte = c.Single(nullable:=False),
                        .FormaPagament = c.Int(nullable:=False),
                        .NumVenciments = c.Byte(nullable:=False),
                        .Observacions = c.String()
                    }) _
                .PrimaryKey(Function(t) t.PressupostId) _
                .ForeignKey("dbo.CLIENTS", Function(t) t.ClientId, cascadeDelete:=True) _
                .Index(Function(t) t.ClientId)

            CreateTable(
                "dbo.PRESSUPOSTOS_LIN",
                Function(c) New With
                    {
                        .PressupostId = c.Long(nullable:=False),
                        .Linia = c.Byte(nullable:=False),
                        .ArticleId = c.Long(),
                        .Descripcio = c.String(),
                        .Quantitat = c.Single(nullable:=False),
                        .Preu = c.Double(nullable:=False),
                        .PercDescompte = c.Single(nullable:=False),
                        .PercIVA = c.Single(nullable:=False),
                        .Unitats = c.String()
                    }) _
                .PrimaryKey(Function(t) New With {t.PressupostId, t.Linia}) _
                .ForeignKey("dbo.PRESSUPOSTOS", Function(t) t.PressupostId, cascadeDelete:=True) _
                .ForeignKey("dbo.ARTICLES", Function(t) t.ArticleId) _
                .Index(Function(t) t.PressupostId) _
                .Index(Function(t) t.ArticleId)

            CreateTable(
                "dbo.ARTICLES",
                Function(c) New With
                    {
                        .ArticleId = c.Long(nullable:=False, identity:=True),
                        .Nom = c.String(),
                        .Preu = c.Double(nullable:=False),
                        .Unitats = c.String()
                    }) _
                .PrimaryKey(Function(t) t.ArticleId)

            CreateTable(
                "dbo.FACTURAS_CLI",
                Function(c) New With
                    {
                        .FacturaCliId = c.Long(nullable:=False),
                        .ClientId = c.Long(nullable:=False),
                        .EstatFactura = c.Int(nullable:=False),
                        .Descripcio = c.String(),
                        .Data = c.DateTime(nullable:=False),
                        .Usuari = c.Int(nullable:=False),
                        .PercDescompte = c.Single(nullable:=False),
                        .FormaPagament = c.Int(nullable:=False),
                        .NumVenciments = c.Byte(nullable:=False),
                        .Observacions = c.String()
                    }) _
                .PrimaryKey(Function(t) t.FacturaCliId) _
                .ForeignKey("dbo.PRESSUPOSTOS", Function(t) t.FacturaCliId) _
                .ForeignKey("dbo.CLIENTS", Function(t) t.ClientId) _
                .Index(Function(t) t.FacturaCliId) _
                .Index(Function(t) t.ClientId)

            CreateTable(
                "dbo.FACTURAS_CLI_LIN",
                Function(c) New With
                    {
                        .FacturaCliId = c.Long(nullable:=False),
                        .Linia = c.Byte(nullable:=False),
                        .ArticleId = c.Long(),
                        .Descripcio = c.String(),
                        .Quantitat = c.Single(nullable:=False),
                        .Preu = c.Double(nullable:=False),
                        .PercDescompte = c.Single(nullable:=False),
                        .PercIVA = c.Single(nullable:=False),
                        .Unitats = c.String()
                    }) _
                .PrimaryKey(Function(t) New With {t.FacturaCliId, t.Linia}) _
                .ForeignKey("dbo.FACTURAS_CLI", Function(t) t.FacturaCliId, cascadeDelete:=True) _
                .ForeignKey("dbo.ARTICLES", Function(t) t.ArticleId) _
                .Index(Function(t) t.FacturaCliId) _
                .Index(Function(t) t.ArticleId)

            CreateTable(
                "dbo.COBRAMENTS",
                Function(c) New With
                    {
                        .Id = c.Long(nullable:=False, identity:=True),
                        .ClientId = c.Long(nullable:=False),
                        .FacturaCliId = c.Long(nullable:=False),
                        .Numero = c.Int(nullable:=False),
                        .DataFactura = c.DateTime(nullable:=False),
                        .Import = c.Double(nullable:=False),
                        .DataVenciment = c.DateTime(nullable:=False),
                        .Estat = c.Int(nullable:=False),
                        .FormaPagament = c.Int(nullable:=False),
                        .UltimaReclamacio = c.DateTime(nullable:=False),
                        .Enviat = c.Boolean(nullable:=False),
                        .Missatge = c.String()
                    }) _
                .PrimaryKey(Function(t) t.Id) _
                .ForeignKey("dbo.FACTURAS_CLI", Function(t) t.FacturaCliId, cascadeDelete:=True) _
                .ForeignKey("dbo.CLIENTS", Function(t) t.ClientId) _
                .Index(Function(t) t.FacturaCliId) _
                .Index(Function(t) t.ClientId)

            CreateTable(
                "dbo.PROVEIDORS",
                Function(c) New With
                    {
                        .ProveidorId = c.Long(nullable:=False, identity:=True),
                        .NomContacte = c.String(),
                        .TelefonContacte = c.String(),
                        .NomUsuariWeb = c.String(),
                        .ContrasenyaWeb = c.String(),
                        .ActivatEnWeb = c.Boolean(nullable:=False),
                        .Nom = c.String(),
                        .NIF = c.String(),
                        .Direccio = c.String(),
                        .CP = c.Int(nullable:=False),
                        .Poblacio = c.String(),
                        .Provincia = c.String(),
                        .Pais = c.String(),
                        .Telefon = c.String(),
                        .Movil = c.String(),
                        .Email = c.String(),
                        .Web = c.String()
                    }) _
                .PrimaryKey(Function(t) t.ProveidorId)

            CreateTable(
                "dbo.FACTURAS_PRO",
                Function(c) New With
                    {
                        .FacturaProId = c.Long(nullable:=False),
                        .ProveidorId = c.Long(nullable:=False),
                        .EstatFactura = c.Int(nullable:=False),
                        .EsDespesa = c.Boolean(nullable:=False),
                        .Descripcio = c.String(),
                        .Data = c.DateTime(nullable:=False),
                        .Usuari = c.Int(nullable:=False),
                        .PercDescompte = c.Single(nullable:=False),
                        .FormaPagament = c.Int(nullable:=False),
                        .NumVenciments = c.Byte(nullable:=False),
                        .Observacions = c.String()
                    }) _
                .PrimaryKey(Function(t) t.FacturaProId) _
                .ForeignKey("dbo.PROVEIDORS", Function(t) t.ProveidorId, cascadeDelete:=True) _
                .Index(Function(t) t.ProveidorId)

            CreateTable(
                "dbo.FACTURAS_PRO_LIN",
                Function(c) New With
                    {
                        .FacturaProId = c.Long(nullable:=False),
                        .Linia = c.Byte(nullable:=False),
                        .ArticleId = c.Long(),
                        .Descripcio = c.String(),
                        .Quantitat = c.Single(nullable:=False),
                        .Preu = c.Double(nullable:=False),
                        .PercDescompte = c.Single(nullable:=False),
                        .PercIVA = c.Single(nullable:=False),
                        .Unitats = c.String()
                    }) _
                .PrimaryKey(Function(t) New With {t.FacturaProId, t.Linia}) _
                .ForeignKey("dbo.FACTURAS_PRO", Function(t) t.FacturaProId, cascadeDelete:=True) _
                .ForeignKey("dbo.ARTICLES", Function(t) t.ArticleId) _
                .Index(Function(t) t.FacturaProId) _
                .Index(Function(t) t.ArticleId)

            CreateTable(
                "dbo.PAGAMENTS",
                Function(c) New With
                    {
                        .Id = c.Long(nullable:=False, identity:=True),
                        .ProveidorId = c.Long(nullable:=False),
                        .FacturaProId = c.Long(nullable:=False),
                        .Numero = c.Int(nullable:=False),
                        .DataFactura = c.DateTime(nullable:=False),
                        .Import = c.Double(nullable:=False),
                        .DataVenciment = c.DateTime(nullable:=False),
                        .Estat = c.Int(nullable:=False),
                        .FormaPagament = c.Int(nullable:=False),
                        .UltimaReclamacio = c.DateTime(nullable:=False),
                        .Enviat = c.Boolean(nullable:=False),
                        .Missatge = c.String()
                    }) _
                .PrimaryKey(Function(t) t.Id) _
                .ForeignKey("dbo.FACTURAS_PRO", Function(t) t.FacturaProId, cascadeDelete:=True) _
                .ForeignKey("dbo.PROVEIDORS", Function(t) t.ProveidorId) _
                .Index(Function(t) t.FacturaProId) _
                .Index(Function(t) t.ProveidorId)

            CreateTable(
                "dbo.CONFIGURACIO",
                Function(c) New With
                    {
                        .UsuariId = c.Int(nullable:=False),
                        .Opcio = c.String(nullable:=False, maxLength:=128),
                        .Valor = c.String()
                    }) _
                .PrimaryKey(Function(t) New With {t.UsuariId, t.Opcio})

        End Sub

        Public Overrides Sub Down()
            DropIndex("dbo.PAGAMENTS", New String() {"ProveidorId"})
            DropIndex("dbo.PAGAMENTS", New String() {"FacturaProId"})
            DropIndex("dbo.FACTURAS_PRO_LIN", New String() {"ArticleId"})
            DropIndex("dbo.FACTURAS_PRO_LIN", New String() {"FacturaProId"})
            DropIndex("dbo.FACTURAS_PRO", New String() {"ProveidorId"})
            DropIndex("dbo.COBRAMENTS", New String() {"ClientId"})
            DropIndex("dbo.COBRAMENTS", New String() {"FacturaCliId"})
            DropIndex("dbo.FACTURAS_CLI_LIN", New String() {"ArticleId"})
            DropIndex("dbo.FACTURAS_CLI_LIN", New String() {"FacturaCliId"})
            DropIndex("dbo.FACTURAS_CLI", New String() {"ClientId"})
            DropIndex("dbo.FACTURAS_CLI", New String() {"FacturaCliId"})
            DropIndex("dbo.PRESSUPOSTOS_LIN", New String() {"ArticleId"})
            DropIndex("dbo.PRESSUPOSTOS_LIN", New String() {"PressupostId"})
            DropIndex("dbo.PRESSUPOSTOS", New String() {"ClientId"})
            DropForeignKey("dbo.PAGAMENTS", "ProveidorId", "dbo.PROVEIDORS")
            DropForeignKey("dbo.PAGAMENTS", "FacturaProId", "dbo.FACTURAS_PRO")
            DropForeignKey("dbo.FACTURAS_PRO_LIN", "ArticleId", "dbo.ARTICLES")
            DropForeignKey("dbo.FACTURAS_PRO_LIN", "FacturaProId", "dbo.FACTURAS_PRO")
            DropForeignKey("dbo.FACTURAS_PRO", "ProveidorId", "dbo.PROVEIDORS")
            DropForeignKey("dbo.COBRAMENTS", "ClientId", "dbo.CLIENTS")
            DropForeignKey("dbo.COBRAMENTS", "FacturaCliId", "dbo.FACTURAS_CLI")
            DropForeignKey("dbo.FACTURAS_CLI_LIN", "ArticleId", "dbo.ARTICLES")
            DropForeignKey("dbo.FACTURAS_CLI_LIN", "FacturaCliId", "dbo.FACTURAS_CLI")
            DropForeignKey("dbo.FACTURAS_CLI", "ClientId", "dbo.CLIENTS")
            DropForeignKey("dbo.FACTURAS_CLI", "FacturaCliId", "dbo.PRESSUPOSTOS")
            DropForeignKey("dbo.PRESSUPOSTOS_LIN", "ArticleId", "dbo.ARTICLES")
            DropForeignKey("dbo.PRESSUPOSTOS_LIN", "PressupostId", "dbo.PRESSUPOSTOS")
            DropForeignKey("dbo.PRESSUPOSTOS", "ClientId", "dbo.CLIENTS")
            DropTable("dbo.CONFIGURACIO")
            DropTable("dbo.PAGAMENTS")
            DropTable("dbo.FACTURAS_PRO_LIN")
            DropTable("dbo.FACTURAS_PRO")
            DropTable("dbo.PROVEIDORS")
            DropTable("dbo.COBRAMENTS")
            DropTable("dbo.FACTURAS_CLI_LIN")
            DropTable("dbo.FACTURAS_CLI")
            DropTable("dbo.ARTICLES")
            DropTable("dbo.PRESSUPOSTOS_LIN")
            DropTable("dbo.PRESSUPOSTOS")
            DropTable("dbo.CLIENTS")
            DropTable("dbo.USUARIS")
        End Sub
    End Class
End Namespace
