﻿Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations.Schema

Namespace ModelLayer

    <Schema.Table("USUARIS")>
    <DataContract>
    Public Class Usuari

        <DataMember>
        <Key()>
        <DatabaseGeneratedAttribute(DatabaseGeneratedOption.Identity)>
        Public Property UsuariId As Integer


        ''' <summary>
        ''' Login de l'usuari
        ''' </summary>
        <DataMember>
        Public Property NomUsuari As String


        ''' <summary>
        ''' Nom Complet de l'usuari
        ''' </summary>
        <DataMember>
        Public Property NomComplet As String


        ''' <summary>
        ''' Contrassenya d'accés a l'aplicació
        ''' </summary>
        <DataMember>
        Public Property Contrassenya As String

        <DataMember>
        <DefaultValue(EnumTipusUsuari.UsuariComu)>
        Public Property Tipus As EnumTipusUsuari?

        <DataMember>
        Public Property DataAlta As Date?

        <DataMember>
        <DefaultValue(EnumEstatsUsuari.Actiu)>
        Public Property Estat As EnumEstatsUsuari?

        <DataMember>
        Public Property DataBaixa As Date?

        <DataMember>
        Public Property DataUltimAcces As Date?

        <DataMember>
        Public Property Nom As String

        <DataMember>
        <DefaultValue(True)>
        Public Property AccesClients As Boolean?

        <DataMember>
        <DefaultValue(True)>
        Public Property AccesProveidors As Boolean?

        <DataMember>
        <DefaultValue(True)>
        Public Property AccesPressupostos As Boolean?

        <DataMember>
        <DefaultValue(True)>
        Public Property AccesPresupostos As Boolean?

        <DataMember>
        <DefaultValue(True)>
        Public Property AccesFacturesCli As Boolean?

        <DataMember>
        <DefaultValue(True)>
        Public Property AccesFacturesPro As Boolean?

        <DataMember>
        <DefaultValue(True)>
        Public Property AccesFacturesDes As Boolean?

        <DataMember>
        <DefaultValue(True)>
        Public Property AccesCobraments As Boolean?

        <DataMember>
        <DefaultValue(True)>
        Public Property AccesPagaments As Boolean?

        <DataMember>
        <DefaultValue(True)>
        Public Property AccesContabilitat As Boolean?

        <DataMember>
        <DefaultValue(True)>
        Public Property AccesWindowsPhone As Boolean?



#Region "Mètodes Concrets"

        Public Overloads Sub FromObject(ByRef oUsuari As Usuari)

            With oUsuari
                Me.UsuariId = .UsuariId
                Me.NomUsuari = .NomUsuari
                Me.NomComplet = .NomComplet
                Me.Contrassenya = .Contrassenya
                Me.Tipus = .Tipus
                Me.Estat = .Estat
                Me.DataBaixa = .DataBaixa
                Me.DataUltimAcces = .DataUltimAcces
                Me.DataAlta = .DataAlta
            End With
        End Sub

#End Region

    End Class

    Public Class RegisterExternalLoginModel
        <Required()> _
        <Display(Name:="Nombre de usuario")> _
        Public Property UserName As String

        Public Property ExternalLoginData As String
    End Class

    Public Class LocalPasswordModel
        <Required()> _
        <DataType(DataType.Password)> _
        <Display(Name:="Contraseña actual")> _
        Public Property OldPassword As String

        <Required()> _
        <StringLength(100, ErrorMessage:="El número de caracteres de {0} debe ser al menos {2}.", MinimumLength:=6)> _
        <DataType(DataType.Password)> _
        <Display(Name:="Nueva contraseña")> _
        Public Property NewPassword As String

        <DataType(DataType.Password)> _
        <Display(Name:="Confirmar la nueva contraseña")> _
        <System.ComponentModel.DataAnnotations.Compare("NewPassword", ErrorMessage:="La nueva contraseña y la contraseña de confirmación no coinciden.")> _
        Public Property ConfirmPassword As String
    End Class

    Public Class LoginModel
        <Required()> _
        <Display(Name:="Nombre de usuario")> _
        Public Property UserName As String

        <Required()> _
        <DataType(DataType.Password)> _
        <Display(Name:="Contraseña")> _
        Public Property Password As String

        <Display(Name:="¿Recordar cuenta?")> _
        Public Property RememberMe As Boolean
    End Class

    Public Class RegisterModel
        <Required()> _
        <Display(Name:="Nombre de usuario")> _
        Public Property UserName As String

        <Required()> _
        <StringLength(100, ErrorMessage:="El número de caracteres de {0} debe ser al menos {2}.", MinimumLength:=6)> _
        <DataType(DataType.Password)> _
        <Display(Name:="Contraseña")> _
        Public Property Password As String

        <DataType(DataType.Password)> _
        <Display(Name:="Confirmar contraseña")> _
        <System.ComponentModel.DataAnnotations.Compare("Password", ErrorMessage:="La contraseña y la contraseña de confirmación no coinciden.")> _
        Public Property ConfirmPassword As String
    End Class

    Public Class ExternalLogin
        Public Property Provider As String
        Public Property ProviderDisplayName As String
        Public Property ProviderUserId As String
    End Class

End Namespace
