﻿Imports System.Data.Entity
Imports System.Data.Entity.ModelConfiguration.Conventions
Imports AppGestio.ModelLayer

Namespace DataLayer
    'Public Class MyServiceConfiguration
    '    Inherits System.Data.Entity.DbConfiguration

    '    Sub New()
    '        SetProviderServices(SqlServer.SqlProviderServices.ProviderInvariantName,
    '                            SqlServer.SqlProviderServices.Instance)
    '        SetDatabaseInitializer(Of ServiceWCFContext)(New customdbinicializer(Of ServiceWCFContext))
    '    End Sub

    'End Class

    Public Class ServiceWCFContext
        Inherits DbContext

        Sub New()
            MyBase.New("BaseDadesCnn")
        End Sub

        Public Property USUARIS As DbSet(Of Usuari)
        Public Property CLIENTS As DbSet(Of Client)
        Public Property PROVEIDORS As DbSet(Of Proveidor)
        Public Property PRESSUPOSTOS As DbSet(Of Pressupost)
        Public Property FACTURES_CLI As DbSet(Of FacturaCli)
        Public Property FACTURES_PRO As DbSet(Of FacturaPro)
        Public Property PAGAMENTS As DbSet(Of Pagament)
        Public Property COBRAMENTS As DbSet(Of Cobrament)
        Public Property ARTICLES As DbSet(Of Article)
        Public Property CONFIGURACIONS As DbSet(Of Configuracio)
        Public Property DOCUMENTS As DbSet(Of Document)



        Protected Overrides Sub OnModelCreating(modelBuilder As DbModelBuilder)
            modelBuilder.Conventions.Remove(Of PluralizingTableNameConvention)()
            'modelBuilder.Conventions.Remove(Of OneToManyCascadeDeleteConvention)()

            '|FACTURES_CLI| * ------- 1 |CLIENT| >> Delete cascade = false
            modelBuilder.Entity(Of FacturaCli)().HasRequired(Of Client)(Function(f) f.Client).
                WithMany(Function(c) c.FacturaClis).HasForeignKey(Function(f) f.ClientId).WillCascadeOnDelete(False)

            '|PAGAMENTS| * ------- 1 |PROVEIDOR| >> Delete cascade = false
            modelBuilder.Entity(Of Pagament)().HasRequired(Of Proveidor)(Function(p) p.Proveidor).
                WithMany(Function(p) p.Pagaments).HasForeignKey(Function(p) p.ProveidorId).WillCascadeOnDelete(False)

            '|Cobraments| * ------- 1 |CLIENT| >> Delete cascade = false
            modelBuilder.Entity(Of Cobrament)().HasRequired(Of Client)(Function(f) f.Client).
                WithMany(Function(c) c.Cobraments).HasForeignKey(Function(f) f.ClientId).WillCascadeOnDelete(False)
        End Sub


    End Class
End Namespace

