﻿Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.ComponentModel

Namespace ModelLayer

    <DataContract>
    Public MustInherit Class Linia

        <DataMember>
        Public Property ArticleId As Long?

        <DataMember>
        Public Property Descripcio As String

        <DataMember>
        Public Property Quantitat As Single

        <DataMember>
        Public Property Preu As Double

        <DataMember>
        Public Property PercDescompte As Single

        <DataMember>
        Public Property PercIVA As Single

        <DataMember>
        Public Property Unitats As String


#Region "Propietats de navegació"
        <DataMember>
        Public Overridable Property Article As Article
#End Region

#Region "Propietats calculades"
        <DataMember>
        Public ReadOnly Property Base As Double
            Get
                Return ((100 - PercDescompte) / 100 * Preu) * Quantitat
            End Get
        End Property

        <DataMember>
        Public ReadOnly Property IVALinia As Double
            Get
                Return Base * PercIVA
            End Get
        End Property

        <DataMember>
        Public ReadOnly Property Import As Double
            Get
                Return Base + IVALinia
            End Get
        End Property

#End Region

#Region "Mètodes Concrets"

        Public Sub FromObject(ByRef oLinia As Linia)
            With oLinia
                Me.ArticleId = .ArticleId
                Me.Descripcio = .Descripcio
                Me.Quantitat = .Quantitat
                Me.Preu = .Preu
                Me.PercDescompte = .PercDescompte
                Me.PercIVA = .PercIVA
                Me.Unitats = .Unitats
            End With
        End Sub

#End Region

    End Class
End Namespace
