﻿Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.ComponentModel


Namespace ModelLayer

    <Schema.Table("CLIENTS")>
    Public Class Client
        Inherits Persona

        <Key>
        <DataMember>
        Public Property ClientId As Long

        Sub New()
            MyBase.New()

            Pressuposts = New List(Of Pressupost)
            FacturaClis = New List(Of FacturaCli)
            Cobraments = New List(Of Cobrament)
        End Sub

#Region "Propietats de Navegació"
        <DataMember>
        Public Overridable Property Pressuposts As ICollection(Of Pressupost)

        <DataMember>
        Public Overridable Property FacturaClis As ICollection(Of FacturaCli)

        <DataMember>
        Public Overridable Property Cobraments As ICollection(Of Cobrament)

#End Region

#Region "Mètodes Concrets"

        Public Overloads Sub FromObject(ByRef oClient As Client)

            MyBase.FromObject(oClient)

            With oClient
                Me.ClientId = .ClientId
            End With
        End Sub

#End Region

#Region "Mètodes Abstractes"

        Public Shared Function GetSampleList() As List(Of Client)

            Dim l As New List(Of Client)

            l.Add(New Client With {
                  .ClientId = 1, .Nom = "Jose Pérez", .NIF = "776558558C",
                  .Direccio = "Carrer Balmes 234", .Poblacio = "Barcelona", .Provincia = "Barcelona",
                  .CP = 8543, .Pais = "ESP", .Telefon = "954844744", .Movil = "699599899",
                  .Email = "alguien@algo.com"})

            l.Add(New Client With {
                  .ClientId = 2, .Nom = "Clara Garcia", .NIF = "887554221D",
                  .Direccio = "Carrer Industria 234", .Poblacio = "Barcelona", .Provincia = "Barcelona",
                  .CP = 8040, .Pais = "ESP", .Telefon = "957534744", .Movil = "699540279",
                  .Email = "alguienmas@algomas.com"})


            Return l
        End Function

#End Region

    End Class
End Namespace
