﻿Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.ComponentModel

Namespace ModelLayer

    <Schema.Table("FACTURAS_CLI")>
    <DataContract>
    Public Class FacturaCli
        Inherits Capcalera

        Public Event EstatChanged As EventHandler

#Region "Constructor"
        Sub New()
            MyBase.New()
        End Sub

        Sub New(idFactura As Long)
            Me.New()
            Me.FacturaCliId = idFactura
        End Sub
#End Region


        <Key, Schema.ForeignKey("Pressupost"),
        Schema.DatabaseGenerated(Schema.DatabaseGeneratedOption.None)>
        <DataMember>
        Public Property FacturaCliId As Long

        <DataMember>
        Public Property ClientId As Long

        <DataMember>
        Public Property EstatFactura As EnumEstatsFactura

        <DataMember>
        <UIHint("FacturaCliLin")>
        Public Overridable Property LiniesFactura As ICollection(Of FacturaCliLin)


#Region "Propietats Calculades"
        <DataMember>
        Public ReadOnly Property Suma As Double
            Get
                If LiniesFactura Is Nothing OrElse LiniesFactura.Count = 0 Then
                    Return 0
                Else
                    Return (From L As FacturaCliLin In LiniesFactura Select CDbl(L.Preu * L.Quantitat)).Sum
                End If
            End Get
        End Property

        <DataMember>
        Public ReadOnly Property IVA As Double
            Get
                If LiniesFactura Is Nothing OrElse LiniesFactura.Count = 0 Then
                    Return 0
                Else
                    Return (From L As FacturaCliLin In LiniesFactura Select L.IVALinia).Sum
                End If
            End Get
        End Property

        <DataMember>
        Public ReadOnly Property Descompte As Double
            Get
                Return Suma * PercDescompte / 100
            End Get
        End Property

        <DataMember>
        Public ReadOnly Property Import As Double
            Get
                Return (From L As FacturaCliLin In LiniesFactura Select Imp = L.Import).Sum
            End Get
        End Property
#End Region

#Region "Propietats de navegació"
        <DataMember>
        Public Overridable Property Pressupost As Pressupost

        <DataMember>
        Public Overridable Property Cobraments As ICollection(Of Cobrament)

        <DataMember>
        Public Overridable Property Client As Client
#End Region

#Region "Mètodes Concrets"
        Private Sub CanviarEstatFactura(NouEstat As EnumEstatsFactura)
            Throw New NotImplementedException
        End Sub

        Public Function ObtenirCobraments() As ICollection(Of Cobrament)
            Throw New NotImplementedException
        End Function

        Public Overloads Sub FromObject(ByRef oFacturaCli As FacturaCli)

            MyBase.FromObject(oFacturaCli)

            With oFacturaCli
                Me.FacturaCliId = .FacturaCliId
                Me.EstatFactura = .EstatFactura
                Me.LiniesFactura = .LiniesFactura
            End With
        End Sub
#End Region



    End Class
End Namespace