﻿Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.ComponentModel

Namespace ModelLayer

    <Schema.Table("PRESSUPOSTOS")>
    <DataContract>
    Public Class Pressupost
        Inherits Capcalera

        Public Event EstatChanged As EventHandler

#Region "Constructor"
        Sub New(idPressupost As Long)
            Me.New()
            Me.PressupostId = idPressupost

        End Sub

        Sub New()
            MyBase.New()
            Me.LiniesPressupost = New List(Of PressupostLin)
        End Sub
#End Region

        <Key,
        Schema.DatabaseGenerated(Schema.DatabaseGeneratedOption.None)>
        <DataMember>
        Public Property PressupostId As Long


        <DataMember>
        Public Property ClientId As Long

        <Required>
        <DataMember>
        Public Property EstatPressupost As EnumEstatsPressupost

        <DataMember>
        <UIHint("PressupostLin")>
        Public Overridable Property LiniesPressupost As ICollection(Of PressupostLin)


#Region "Propietats Calculades"
        <DataMember>
        Public ReadOnly Property Suma As Double
            Get
                If LiniesPressupost Is Nothing OrElse LiniesPressupost.Count = 0 Then
                    Return 0
                Else
                    Return (From L As PressupostLin In LiniesPressupost Select CDbl(L.Preu * L.Quantitat)).Sum
                End If
            End Get
        End Property

        <DataMember>
        Public ReadOnly Property IVA As Double
            Get
                If LiniesPressupost Is Nothing OrElse LiniesPressupost.Count = 0 Then
                    Return 0
                Else
                    Return (From L As PressupostLin In LiniesPressupost Select L.IVALinia).Sum
                End If
            End Get
        End Property

        <DataMember>
        Public ReadOnly Property Descompte As Double
            Get
                Return Suma * PercDescompte / 100
            End Get
        End Property

        <DataMember>
        Public ReadOnly Property Import As Double
            Get
                Try
                    Return (From L As PressupostLin In LiniesPressupost Select Imp = L.Import).Sum
                Catch ex As Exception
                    Return 0
                End Try

            End Get
        End Property
#End Region

#Region "Propietats de navegació"

        <DataMember>
        Public Overridable Property FacturaCli As FacturaCli


        <DataMember>
        Public Overridable Property Client As Client


#End Region

#Region "Mètodes Concrets"
        Private Sub CanviarEstatPressupost(NouEstat As EnumEstatsPressupost)

        End Sub

        Public Overloads Sub FromObject(ByRef oPressupost As Pressupost)

            MyBase.FromObject(oPressupost)

            With oPressupost
                Me.PressupostId = .PressupostId
                Me.EstatPressupost = .EstatPressupost
            End With
        End Sub

#End Region

#Region "Mètodes Abstractes"

        Public Shared Function GetSampleList() As List(Of Pressupost)

            Dim l As New List(Of Pressupost)

            Dim p As Pressupost

            p = New Pressupost With {
                  .PressupostId = 1, .Data = Now,
                  .Descripcio = "Reformar Despatx",
                  .Client = Client.GetSampleList(0),
                  .EstatPressupost = EnumEstatsPressupost.Generat,
                  .FormaPagament = EnumFormesPagament.Comptat,
                  .NumVenciments = 2,
                  .Observacions = "Entregar en 2 setmanes",
                  .PercDescompte = 10,
                  .Usuari = 1}
            p.LiniesPressupost.Add(New PressupostLin With {.ArticleID = 1, .Descripcio = "Pintar paret principal",
                                                           .Linia = 1, .PercIVA = 21, .Pressupost = p, .PressupostId = 1,
                                                           .Preu = 1500, .Quantitat = 1})
            p.LiniesPressupost.Add(New PressupostLin With {.ArticleId = 2, .Descripcio = "Arreglar Terra",
                                                           .Linia = 2, .PercIVA = 21, .Pressupost = p, .PressupostId = 1,
                                                           .Preu = 550, .Quantitat = 1})
            l.Add(p)


            p = New Pressupost With {
                  .PressupostId = 2, .Data = Now,
                  .Descripcio = "Reformar cuina",
                  .Client = Client.GetSampleList(1),
                  .EstatPressupost = EnumEstatsPressupost.Acceptat,
                  .FormaPagament = EnumFormesPagament.Comptat,
                  .NumVenciments = 1,
                  .Observacions = "Entregar en 2 setmanes",
                  .PercDescompte = 25,
                  .Usuari = 1}
            p.LiniesPressupost.Add(New PressupostLin With {.ArticleId = 150, .Descripcio = "Cuina Nova",
                                                           .Linia = 1, .PercIVA = 21, .Pressupost = p, .PressupostId = 2,
                                                           .Preu = 1500, .Quantitat = 1})
            p.LiniesPressupost.Add(New PressupostLin With {.ArticleId = 2, .Descripcio = "Arreglar Terra",
                                                           .Linia = 2, .PercIVA = 21, .Pressupost = p, .PressupostId = 2,
                                                           .Preu = 550, .Quantitat = 1})
            l.Add(p)



            Return l
        End Function

#End Region

    End Class

End Namespace




