﻿Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.ComponentModel

Namespace ModelLayer

    <Schema.Table("FACTURAS_PRO")>
    <DataContract>
    Public Class FacturaPro
        Inherits Capcalera

        Public Event EstatChanged As EventHandler

#Region "Constructor"
        Sub New()
            MyBase.New()
            Me.LiniesFactura = New List(Of FacturaProLin)
        End Sub


        Sub New(idFactura As Long)
            Me.New()
            Me.FacturaProId = idFactura
        End Sub
#End Region

        <Key,
        Schema.DatabaseGenerated(Schema.DatabaseGeneratedOption.None)>
        <DataMember>
        Public Property FacturaProId As Long

        <DataMember>
        Public Property ProveidorId As Long

        <DataMember>
        Public Property EstatFactura As EnumEstatsFacturaPro

        <DataMember>
        Public Property EsDespesa As Boolean

        <DataMember>
        <UIHint("FacturaProLin")>
        Public Overridable Property LiniesFactura As ICollection(Of FacturaProLin)


#Region "Propietats Calculades"
        <DataMember>
        Public ReadOnly Property Suma As Double
            Get
                If LiniesFactura Is Nothing OrElse LiniesFactura.Count = 0 Then
                    Return 0
                Else
                    Return (From L As FacturaProLin In LiniesFactura Select CDbl(L.Preu * L.Quantitat)).Sum
                End If
            End Get
        End Property

        <DataMember>
        Public ReadOnly Property IVA As Double
            Get
                If LiniesFactura Is Nothing OrElse LiniesFactura.Count = 0 Then
                    Return 0
                Else
                    Return (From L As FacturaProLin In LiniesFactura Select L.IVALinia).Sum
                End If
            End Get
        End Property

        <DataMember>
        Public ReadOnly Property Descompte As Double
            Get
                Return Suma * PercDescompte / 100
            End Get
        End Property

        <DataMember>
        Public ReadOnly Property Import As Double
            Get
                If LiniesFactura Is Nothing OrElse LiniesFactura.Count = 0 Then
                    Return 0
                End If
                Return (From L As FacturaProLin In LiniesFactura Select Imp = L.Import).Sum
            End Get
        End Property
#End Region

#Region "Propietats de navegació"

        <DataMember>
        Public Property Proveidor As Proveidor

        <DataMember>
        Public Overridable Property Pagaments As ICollection(Of Pagament)

#End Region


#Region "Mètodes Concrets"

        Public Overloads Sub FromObject(ByRef oFacturaPro As FacturaPro)

            MyBase.FromObject(oFacturaPro)

            With oFacturaPro
                Me.FacturaProId = .FacturaProId
                Me.ProveidorId = .ProveidorId
                Me.EstatFactura = .EstatFactura
                Me.EsDespesa = .EsDespesa
            End With
        End Sub

#End Region


    End Class
End Namespace