﻿Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.ComponentModel

Namespace ModelLayer

    <Schema.Table("PROVEIDORS")>
    <DataContract>
    Public Class Proveidor
        Inherits Persona

        Sub New()
            MyBase.New()
            FacturaPros = New List(Of FacturaPro)
        End Sub

        <Key>
        <DataMember>
        Public Property ProveidorId As Long

        ''' <summary>
        ''' Nom de la persona de contacte
        ''' </summary>
        <DataMember>
        Public Property NomContacte As String

        ''' <summary>
        ''' Telèfon de la persona de contacte
        ''' </summary>
        <DataMember>
        Public Property TelefonContacte As String

        ''' <summary>
        ''' Nom d'usuari per a la web de proveidors
        ''' </summary>
        <DataMember>
        Public Property NomUsuariWeb As String

        ''' <summary>
        ''' Contrassenya per a la web de proveidors
        ''' </summary>
        <DataMember>
        Public Property ContrasenyaWeb As String

        ''' <summary>
        ''' Indica si hi pot accedir via web al mòdul AppExterns
        ''' </summary>
        <DataMember>
        Public Property ActivatEnWeb As Boolean

#Region "Propietats de Navegació"
        <DataMember>
        Public Overridable Property FacturaPros As ICollection(Of FacturaPro)

        <DataMember>
        Public Overridable Property Pagaments As ICollection(Of Pagament)
#End Region

#Region "Mètodes Concrets"

        Public Overloads Sub FromObject(ByRef oProveidor As Proveidor)

            MyBase.FromObject(oProveidor)

            With oProveidor
                Me.ProveidorId = .ProveidorId
                Me.NomContacte = .NomContacte
                Me.TelefonContacte = .TelefonContacte
                Me.NomUsuariWeb = .NomUsuariWeb
                Me.ContrasenyaWeb = .ContrasenyaWeb
                Me.ActivatEnWeb = .ActivatEnWeb

            End With
        End Sub

#End Region

    End Class
End Namespace
