﻿@ModelType IPagedList(Of AppGestio.ModelLayer.Usuari)
@imports PagedList.mvc
@Imports PagedList

@Code
    ViewData("Title") = String.Format("{0}. {1}", Recursos.user_gestioDUsuaris, Recursos.general_index)
End Code

<link href="~/Content/PagedList.css" rel="stylesheet" type="text/css" />

<div>
    <h1>@ViewData("Title")</h1>
</div>

@Using Html.BeginForm("Index", "Account", FormMethod.Get)
    @Html.AntiForgeryToken()

    @<table>
        <tr>
            <td width="100px">@Recursos.label_filtre</td>
            <td width="350px">@Html.TextBox("filtroNombre", Session("CurrentFilter"))</td>
            <td><input type="submit" value="@Recursos.label_filtre" /></td>
        </tr>
    </table>
End Using

<p>
    @Html.ActionLink(Recursos.user_afegir, "Create")
</p>

<table>
    <tr>
        <th width="14%">
            @Html.ActionLink("ID", "Index", New With {.orden = ViewData("IdSortParam")})
        </th>
        <th width="26%">
            @Html.ActionLink(Recursos.camps_nom, "Index", New With {.orden = ViewData("NomSortParam")})
        </th>
        <th width="26%">
            @Html.ActionLink(Recursos.camps_dataalta, "Index", New With {.orden = ViewData("DataAltaSortParam")})
        </th>
        <th width="26%">
            @Html.Label("Text", Recursos.camps_databaixa)
        </th>
        @*<th width="4%">@Html.Label("Text", Recursos.camps_visualitzar)</th>*@
        <th width="4%">@Html.Label("Text", Recursos.camps_editar)</th>
        <th width="4%">@Html.Label("Text", Recursos.camps_eliminar)</th>
    </tr>

    @For Each item In Model
        Dim currentItem = item

        @<tr class="fila_resultats">
            <td>
                @Html.DisplayFor(Function(modelItem) currentItem.UsuariId)
            </td>
            <td>
                @Html.DisplayFor(Function(modelItem) currentItem.NomComplet)
            </td>
            <td>
                @Html.label("Text", CStr(If(currentItem.DataAlta.HasValue,  currentItem.DataAlta.Value, "")))
            </td>
            <td>
               @Html.Label("Text", CStr(If(currentItem.DataBaixa.HasValue, currentItem.DataBaixa.Value, "")))
            </td>
            @*<td>
                <a href="@Url.Action("Details", "Account", New With {.id = currentItem.UsuariId})">
                    <img src="~/Images/iconos/preview.png" height="20" />
                </a>
            </td>*@
            <td>
                <a href="@Url.Action("Edit", "Account", New With {.id = currentItem.UsuariId})">
                    <img src="~/Images/iconos/edit.png" height="20" />
                </a>
            </td>
            <td>
                <a href="@Url.Action("Delete", "Account", New With {.id = currentItem.UsuariId})">
                    <img src="~/Images/iconos/delete.png" height="20" />
                </a>
            </td>
        </tr>
    Next
</table>
<table>
    <tr>
        <td align="right">
            @Recursos.label_pagina @IIf(Model.PageCount < Model.PageNumber, 0, Model.PageNumber) de @Model.PageCount
        </td>
    </tr>
    <tr>
        <td align="right">
            @Html.PagedListPager(Model, Function(page) Url.Action("Index", New With {.orden = ViewData("CurrentSort"), .currentFilter = ViewData("CurrentFilter"), .pagina = page}))
        </td>
    </tr>
</table>
<br />
