﻿@imports PagedList.mvc
@Imports PagedList

@ModelType IPagedList(Of AppGestio.ModelLayer.Article)

@Code
    ViewData("Title") = String.Format("{0}. {1}", Recursos.article_gestioDArticles, Recursos.general_index)
End Code

<link href="~/Content/PagedList.css" rel="stylesheet" type="text/css" />

<div>
    <h1>@ViewData("Title")</h1>
</div>

@Using Html.BeginForm("Index", "Article", FormMethod.Get)
    @Html.AntiForgeryToken()

    @<table>
        <tr>
            <td width="100px">@Recursos.label_filtre</td>
            <td width="350px">@Html.TextBox("filtroNombre", Session("CurrentFilter"))</td>
            <td><input type="submit" value="@Recursos.label_filtre" /></td>
        </tr>
    </table>
End Using

<p>
    @Html.ActionLink(Recursos.article_afegir, "Create")
</p>
<table>
    <tr>
        <th width="13%">
            @Html.ActionLink(Recursos.camps_article, "Index", New With {.orden = ViewData("IdSortParam")})
        </th>
        <th width="25%">
            @Html.ActionLink(Recursos.camps_nom, "Index", New With {.orden = ViewData("NomSortParam")})
        </th>
        <th width="25%">
            @Html.Label("Text", Recursos.camps_preu)
        </th>
        <th width="25%">
            @Html.Label("Text", Recursos.camps_unitats)
        </th>
        <th width="4%">@Html.Label("Text", Recursos.camps_visualitzar)</th>
        <th width="4%">@Html.Label("Text", Recursos.camps_editar)</th>
        <th width="4%">@Html.Label("Text", Recursos.camps_eliminar)</th>
    </tr>

    @For Each item In Model
        Dim currentItem = item
        @<tr>
             <td>
                @Html.DisplayFor(Function(modelItem) currentItem.ArticleId)
             </td>
            <td>
                @Html.DisplayFor(Function(modelItem) currentItem.Nom)
            </td>
            <td>
                @Html.DisplayFor(Function(modelItem) currentItem.Preu)
            </td>
            <td>
                @Html.DisplayFor(Function(modelItem) currentItem.Unitats)
            </td>
             <td>
                 <a href="@Url.Action("Details", "Article", New With {.id = currentItem.ArticleId})">
                     <img src="~/Images/iconos/preview.png" height="20" />
                 </a>
             </td>
             <td>
                 <a href="@Url.Action("Edit", "Article", New With {.id = currentItem.ArticleId})">
                     <img src="~/Images/iconos/edit.png" height="20" />
                 </a>
             </td>
             <td>
                 <a href="@Url.Action("Delete", "Article", New With {.id = currentItem.ArticleId})">
                     <img src="~/Images/iconos/delete.png" height="20" />
                 </a>
             </td>
        </tr>
    Next

</table>
<table>
    <tr>
        <td align="right">
            @Recursos.label_pagina @IIf(Model.PageCount < Model.PageNumber, 0, Model.PageNumber) de @Model.PageCount
        </td>
    </tr>
    <tr>
        <td align="right">
            @Html.PagedListPager(Model, Function(page) Url.Action("Index", New With {.orden = ViewData("CurrentSort"), .currentFilter = ViewData("CurrentFilter"), .pagina = page}))
        </td>
    </tr>
</table>
<br />
