﻿@imports PagedList.mvc
@Imports PagedList

@ModelType  IPagedList(Of AppGestio.ModelLayer.Client)

@Code
    ViewData("Title") = String.Format("{0}. {1}", Recursos.client_gestioDeClients, Recursos.general_index)
End Code

<link href="~/Content/PagedList.css" rel="stylesheet" type="text/css" />

<div>
    <h1>@ViewData("Title")</h1>
</div>


@Using Html.BeginForm("Index", "Client", FormMethod.Get)
    @Html.AntiForgeryToken()
    
    @<table>
        <tr>
            <td width="100px">@Recursos.label_filtre</td>
            <td width="350px">@Html.TextBox("filtroNombre", Session("CurrentFilter"))</td>
            <td><input type="submit" value="@Recursos.label_filtre" /></td>
        </tr>
    </table>
End Using
    
    

<p>
    @Html.ActionLink(Recursos.client_afegir, "Create")
</p>
<table>
    <tr>
        <th width="13%">
            @Html.ActionLink(Recursos.camps_client, "Index", New With {.orden = ViewData("IdSortParam")})
            @*@Html.Label("Text", Recursos.camps_client)*@
        </th>
        <th width="25%">
            @Html.ActionLink(Recursos.camps_nom, "Index", New With {.orden = ViewData("NomSortParam")})
            @*@Html.Label("Text", Recursos.camps_nom)*@
        </th>
        <th width="25%">
            @Html.ActionLink(Recursos.camps_NIF, "Index", New With {.orden = ViewData("NifSortParam")})
            @*@Html.Label("Text", Recursos.camps_NIF)*@
        </th>
        <th width="25%">
            @Html.Label("Text", Recursos.camps_Email)
        </th>
        <th width="4%">@Html.Label("Text", Recursos.camps_visualitzar)</th>
        <th width="4%">@Html.Label("Text", Recursos.camps_editar)</th>
        <th width="4%">@Html.Label("Text", Recursos.camps_eliminar)</th>
    </tr>

@For Each item In Model
    Dim currentItem = item
    
    @<tr class="fila_resultats">
         <td>
             @Html.DisplayFor(Function(modelItem) currentItem.ClientId)
         </td>
        <td>
            @Html.DisplayFor(Function(modelItem) currentItem.Nom)
        </td>
         <td>
             @Html.DisplayFor(Function(modelItem) currentItem.NIF)
         </td>
         <td>
             @Html.DisplayFor(Function(modelItem) currentItem.Email)
         </td>
        <td>
            <a href="@Url.Action("Details", "Client", New With {.id = currentItem.ClientId})">
                <img src="~/Images/iconos/preview.png" height="20" />
            </a>
            @*@Html.ActionLink("Details", "Details", New With {.id = currentItem.ClientId})*@ 
        </td>
         <td>
             <a href="@Url.Action("Edit", "Client", New With {.id = currentItem.ClientId})">
                 <img src="~/Images/iconos/edit.png" height="20" />
             </a>
             @*@Html.ActionLink("Edit", "Edit", New With {.id = currentItem.ClientId})*@
         </td>
         <td>
             <a href="@Url.Action("Delete", "Client", New With {.id = currentItem.ClientId})">
                 <img src="~/Images/iconos/delete.png" height="20" />
             </a>
             @*@Html.ActionLink("Delete", "Delete", New With {.id = currentItem.ClientId})*@
         </td>
    </tr>
Next
</table>
<table>
    <tr>
        <td align="right">
            @Recursos.label_pagina @IIf(Model.PageCount < Model.PageNumber, 0, Model.PageNumber) de @Model.PageCount
        </td>
    </tr>
    <tr>
        <td align="right">
           @Html.PagedListPager(Model, Function(page) Url.Action("Index", New With {.orden = ViewData("CurrentSort"), .currentFilter = ViewData("CurrentFilter"), .pagina = page}))
        </td>
    </tr>
</table>
<br />


