﻿@ModelType AppGestio.ModelLayer.FacturaCli

@Code
    ViewData("Title") = String.Format("{0}. {1}", Recursos.fact_gestioDeFactures, Recursos.fact_detalls)
End Code

<div>
    <h1>@ViewData("Title")</h1>
</div>
@Using Html.BeginForm()
    @Html.AntiForgeryToken()
    
    @<fieldset>
    <legend>FacturaCli</legend>
    <table>
        <tr>
            <td width="6%">@Html.Label("Text", "Id:")</td>
            <td width="12%">@Html.Label("Text", Model.FacturaCliId.ToString, New With {.class = "camp-id"})</td>
            <td width="10%">@Html.Label("Text", Recursos.camps_client & ":")</td>
            <td width="40%">@Html.Label("Text", CStr(If(Model.Client Is Nothing, "", Model.Client.ClientId & " - " & Model.Client.Nom)))</td>
            <td width="10%">@Recursos.camps_estat :</td>
            <td width="20%">@Html.Label("Text", Model.EstatFactura.ToString)</td>
        </tr>
    </table>
    <table>
        <tr>
            <td width="15%">
                @Html.Label("Text", Recursos.camps_descripcio & ":")
            </td>
            <td width="85%">
                @Html.LabelFor(Function(model) model.Descripcio, New With {.class = "camp-descripcio"})
            </td>
        </tr>
    </table>
    <table>
        <tr>
            <td width="6%">@Html.Label("Text", Recursos.camps_data & ":")</td>
            <td width="14%">@Html.Label("Text", Model.Data.ToShortDateString)</td>
            <td width="15%">@Html.Label("Text", Recursos.label_descompte & ":")</td>
            <td width="10%">
                @Html.Label("Text", Model.PercDescompte.ToString("0.00"), New With {.class = "camp-percdesc"})
            </td>
            <td width="15%">@Html.Label("Text", Recursos.label_num_venc & ":")</td>
            <td width="10%">
                @Html.Label("Text", Model.NumVenciments.ToString, New With {.class = "camp-numvenc"})
            </td>
        </tr>
    </table>
    
        @If Model.LiniesFactura IsNot Nothing Then
            @Html.DisplayFor(Function(model) model.LiniesFactura)
        End If

    <table>
        <tr>
            <td width="80%"></td>
            <td width="10%">@Html.Label("Text", Recursos.label_suma & ":")</td>
            <td width="10%">@Html.Label(Model.Suma.ToString("0.00"))</td>
        </tr>
        <tr>
            <td width="80%"></td>
            <td width="10%">@Html.Label("Text", Recursos.label_IVA & ":")</td>
            <td width="10%">@Html.Label(Model.IVA.ToString("0.00"))</td>
        </tr>
        <tr>
            <td width="80%"></td>
            <td width="10%">@Html.Label("Text", Recursos.label_import & ":")</td>
            <td width="10%">@Html.Label(Model.Import.ToString("N2"))</td>
        </tr>
    </table>

    <div class="editor-label">
        @Html.Label("Text", Recursos.label_obs & ":", New With {.class = "marge-taules"})
    </div>
    <div class="editor-field">
        @Html.Label("Text", If(Model.Observacions Is Nothing, "", Model.Observacions), New With {.class = "camp-textarea"})
    </div>

         @Select Case Model.EstatFactura
                 Case AppGestio.EnumEstatsFactura.Generada
             @<p>
                  <input type="submit" name="boton" value="@Recursos.camps_eliminar" class="marge-taules" />
                  <input type="submit" name="boton" value="@Recursos.button_acceptar" class="marge-taules" />
             </p>
         Case AppGestio.EnumEstatsFactura.Acceptada
             @<p>
                <input type="submit" name="boton" value="@Recursos.button_anular" class="marge-taules" />
                <input type="submit" name="boton" value="@Recursos.button_facturar" class="marge-taules" />
            </p>
         Case AppGestio.EnumEstatsFactura.Facturada
            @<p>
                <input type="submit" name="boton" value="@Recursos.button_anular" class="marge-taules" />
            </p>
     End Select

    </fieldset>
End Using
<p>
    @Html.ActionLink(Recursos.button_tornarALlista, "Index")
</p>
