﻿@ModelType IEnumerable(Of AppGestio.ModelLayer.FacturaCli)

@Code
    ViewData("Title") = String.Format("{0}. {1}", Recursos.fact_gestioDeFactures, Recursos.general_index)
End Code

<div>
    <h1>@ViewData("Title")</h1>
</div>

@Using (Html.BeginForm)
    @<table>
        <tr>
            <td width="100px">@Html.Label("Text", Recursos.label_dataIni & ":")</td>
            <td width="120px">@Html.TextBox("txtFechaIni", value:=Now.AddMonths(-1).ToString("dd/MM/yyyy"), htmlAttributes:=New With {.class = "datefield", .type = "string", .style = "width: 100px"})</td>
            <td width="100px">@Html.Label("Text", Recursos.label_datafi & ":")</td>
            <td width="120px">@Html.TextBox("txtFechaFin", value:=Now.ToString("dd/MM/yyyy"), htmlAttributes:=New With {.class = "datefield", .type = "string", .style = "width: 100px"})</td>
            <td><input type="submit" value="@Recursos.button_aplicar" /></td>
        </tr>
    </table>
End Using

<table>
    <tr>
        <th width="12%">
            @Html.Label("Text", Recursos.label_pressupost)
        </th>
        <th width="18%">
            @Html.Label("Text", Recursos.camps_data)
        </th>
        <th width="20%">
            @Html.Label("Text", Recursos.camps_descripcio)
        </th>
        <th width="23%">
            @Html.Label("Text", Recursos.camps_client)
        </th>
        <th width="10%">
            @Html.Label("Text", Recursos.camps_estat)
        </th>
        <th width="3%"></th>
        <th width="5%"></th>
        <th width="5%"></th>

    </tr>
    @If Model IsNot Nothing Then
        @For Each item In Model
            Dim currentItem = item
            @<tr>
                <td>
                    @Html.Label("Text", currentItem.FacturaCliId.ToString)
                </td>
                 <td>
                     @Html.Label("Text", If(currentItem.Data = Nothing, "", currentItem.Data.ToShortDateString))
                 </td>
                 <td>
                     @Html.Label("Text", CStr(If(currentItem.Descripcio Is Nothing, "", currentItem.Descripcio)))
                 </td>
                 <td>
                     @Html.Label("Text", currentItem.Client.ClientId & " - " & currentItem.Client.Nom)
                 </td>
                <td>
                    @Html.Label("Text", currentItem.EstatFactura.ToString)
                </td>
                <td>
                    <a href="@Url.Action("Details", "FacturaCli", New With {.id = currentItem.FacturaCliId})">
                        <img src="~/Images/iconos/preview.png" height="20" />
                    </a>
                </td>
                @Select Case currentItem.EstatFactura
                Case AppGestio.EnumEstatsFactura.Generada
                    @<td>
                        @Html.ActionLink(linkText:=Recursos.camps_eliminar, actionName:="Delete", controllerName:="FacturaCli", routeValues:=New With {.id = currentItem.FacturaCliId}, htmlAttributes:="")
                    </td>
                    @<td>
                        @Html.ActionLink(linkText:=Recursos.button_acceptar, actionName:="Acceptar", controllerName:="FacturaCli", routeValues:=New With {.id = currentItem.FacturaCliId}, htmlAttributes:="")
                    </td>
                Case AppGestio.EnumEstatsFactura.Acceptada
                    @<td>
                        @Html.ActionLink(linkText:=Recursos.button_anular, actionName:="Anular", controllerName:="FacturaCli", routeValues:=New With {.id = currentItem.FacturaCliId}, htmlAttributes:="")
                    </td>
                    @<td>
                        @Html.ActionLink(linkText:=Recursos.button_facturar, actionName:="Facturar", controllerName:="FacturaCli", routeValues:=New With {.id = currentItem.FacturaCliId}, htmlAttributes:="")
                    </td>
                Case AppGestio.EnumEstatsFactura.Facturada
                    @<td>
                        @Html.ActionLink(linkText:=Recursos.button_anular, actionName:="Anular", controllerName:="FacturaCli", routeValues:=New With {.id = currentItem.FacturaCliId}, htmlAttributes:="")
                    </td>
                    @<td></td>
                Case Else
                    @<td></td>
                    @<td></td>
                End Select
            </tr>
                Next

    End If

</table>
