﻿@ModelType AppGestio.ModelLayer.FacturaPro

@Code
    ViewData("Title") = String.Format("{0}. {1}", Recursos.fact_gestioDeFactures, Recursos.camps_editar)
End Code

<div>
    <h1>@ViewData("Title")</h1>
</div>

@Using Html.BeginForm()
    @Html.AntiForgeryToken()
    @Html.ValidationSummary(True)

    @<fieldset>
    <legend>FacturaPro</legend>

    <table>
        <tr>
            <td width="6%">@Html.Label("Text", "Id:")</td>
            <td width="12%">@Html.Label("Text", CStr(Model.FacturaProId), New With {.class = "camp-id"})</td>
            <td width="10%">@Html.Label("Text", Recursos.camps_client & ":")</td>
            <td width="40%">
                @Html.DropDownListFor(Function(model) model.ProveidorId,
                                                      New SelectList(ViewData("proveidors"), "ProveidorId", "Nom"))
            </td>
            <td width="10%">@Recursos.camps_estat :</td>
            <td width="20%">@Html.Label("Text", Model.EstatFactura.ToString)</td>
        </tr>
    </table>
    <table>
        <tr>
            <td width="15%">
                @Html.Label("Text", Recursos.camps_descripcio & ":")
            </td>
            <td width="85%">
                @Html.TextBoxFor(Function(model) model.Descripcio, New With {.class = "camp-descripcio"})
                @Html.ValidationMessageFor(Function(model) model.Descripcio)
            </td>
        </tr>
    </table>
    <table>
        <tr>
            <td width="6%">@Html.Label("Text", Recursos.camps_data & ":")</td>
            <td width="14%">
                @Html.TextBoxFor(Function(model) model.Data, htmlAttributes:=New With {.class = "datefield", .type = "string", .style = "width: 100px"})
                @Html.ValidationMessageFor(Function(model) model.Data)
            </td>
            <td width="15%">@Html.Label("Text", Recursos.label_descompte & ":")</td>
            <td width="10%">
                @Html.TextBoxFor(Function(model) model.PercDescompte, New With {.class = "camp-percdesc"})
                @Html.ValidationMessageFor(Function(model) model.PercDescompte)
            </td>
            <td width="15%">@Html.Label("Text", Recursos.label_num_venc & ":")</td>
            <td width="10%">
                @Html.TextBoxFor(Function(model) model.NumVenciments, New With {.class = "camp-numvenc"})
                @Html.ValidationMessageFor(Function(model) model.NumVenciments)
            </td>
        </tr>
    </table>
    <br />
    @If Model.LiniesFactura IsNot Nothing Then
        @Html.EditorFor(Function(model) model.LiniesFactura)
    End If

    @*<input type="submit" name="boton" value="@Recursos.button_addLinea" class="marge-taules" />
        <input type="submit" name="boton" value="@Recursos.button_aplicar" class="marge-taules" />*@

    <table>
        <tr>
            <td width="70%"></td>
            <td width="15%">@Html.Label("Text", Recursos.label_suma & ":")</td>
            <td width="15%">@Html.Label(Model.Suma.ToString("0.00"))</td>
        </tr>
        <tr>
            <td width="70%"></td>
            <td width="15%">@Html.Label("Text", Recursos.label_IVA & ":")</td>
            <td width="15%">@Html.Label(Model.IVA.ToString("0.00"))</td>
        </tr>
        <tr>
            <td width="70%"></td>
            <td width="15%">@Html.Label("Text", Recursos.label_import & ":")</td>
            <td width="15%">@Html.Label(Model.Import.ToString("0.00"))</td>
        </tr>
    </table>

    <div class="editor-label">
        @Html.Label("Text", Recursos.label_obs, New With {.class = "marge-taules"})
    </div>
    <div class="editor-field">
        @Html.TextAreaFor(Function(model) model.Observacions, New With {.class = "camp-textarea"})
        @Html.ValidationMessageFor(Function(model) model.Observacions)
    </div>

    <p>
        @If Model.EstatFactura = AppGestio.EnumEstatsFacturaPro.Generada Then
            @<input type="submit" name="boton" value="@Recursos.button_guardar" class="marge-taules" />
            @<input type="submit" name="boton" value="@Recursos.button_facturar" class="marge-taules" />
        ElseIf Model.EstatFactura = AppGestio.EnumEstatsFacturaPro.Facturada Then
            @<input type="submit" name="boton" value="@Recursos.button_anular" class="marge-taules" />
        End If
    </p>
</fieldset>
End Using

<div class="marge-taules">
    @Html.ActionLink(Recursos.button_tornarALlista, "Index")
</div>

@Section Scripts
    @Scripts.Render("~/bundles/jqueryval")
End Section
