﻿@ModelType IEnumerable(Of AppGestio.ModelLayer.FacturaPro)

@Code
    ViewData("Title") = String.Format("{0}. {1}", Recursos.label_factures, Recursos.general_index)
End Code

<div>
    <h1>@ViewData("Title")</h1>
</div>

<p>
    @Html.ActionLink("Recursos.facturapro_afegir", "Create")
</p>

@Using (Html.BeginForm)
    @<table>
        <tr>
            <td width="100px">@Html.Label("Text", Recursos.camps_data & ":")</td>
            <td width="120px">@Html.TextBox("txtFechaIni", value:=Now.AddMonths(-1).ToString("dd/MM/yyyy"), htmlAttributes:=New With {.class = "datefield", .type = "string", .style = "width: 100px"})</td>
            <td width="100px">@Html.Label("Text", Recursos.camps_data & ":")</td>
            <td width="120px">@Html.TextBox("txtFechaFin", value:=Now.ToString("dd/MM/yyyy"), htmlAttributes:=New With {.class = "datefield", .type = "string", .style = "width: 100px"})</td>
            <td><input type="submit" value="@Recursos.button_aplicar" /></td>
        </tr>
    </table>
End Using
<table>
    <tr>
        <th width="12%">
            @Html.Label("Text", Recursos.label_pressupost)
        </th>
        <th width="18%">
            @Html.Label("Text", Recursos.camps_data)
        </th>
        <th width="25%">
            @Html.Label("Text", Recursos.camps_descripcio)
        </th>
        <th width="23%">
            @Html.Label("Text", Recursos.camps_client)
        </th>
        <th width="10%">
            @Html.Label("Text", Recursos.camps_estat)
        </th>
        <th width="4%">@Html.Label("Text", Recursos.camps_visualitzar)</th>
        <th width="4%">@Html.Label("Text", Recursos.camps_editar)</th>
        <th width="4%">@Html.Label("Text", Recursos.camps_eliminar)</th>
    </tr>
    @If Model IsNot Nothing Then
        @For Each item In Model
            Dim currentItem = item
            @<tr>
                <td>
                    @Html.Label("Text", CStr(currentItem.FacturaProId))
                </td>
                <td>
                    @Html.Label("Text", If(currentItem.Data = Nothing, "", currentItem.Data.ToShortDateString))
                </td>
                <td>
                    @Html.Label("Text", CStr(If(currentItem.Descripcio Is Nothing, "", currentItem.Descripcio)))
                </td>
                <td>
                    @Html.Label("Text", currentItem.Proveidor.ProveidorId & " - " & currentItem.Proveidor.Nom)
                </td>
                <td>
                    @Html.Label("Text", currentItem.EstatFactura.ToString)
                </td>
                <td>
                    <a href="@Url.Action("Details", "FacturaPro", New With {.id = currentItem.FacturaProId})">
                        <img src="~/Images/iconos/preview.png" height="20" />
                    </a>
                    
                </td>
                <td>
                    @If currentItem.EstatFactura = AppGestio.EnumEstatsFacturaPro.Generada Then
                        @<a href="@Url.Action("Edit", "FacturaPro", New With {.id = currentItem.FacturaProId})">
                            <img src="~/Images/iconos/edit.png" height="20" />
                        </a>
                    End If
                </td>
                <td>
                    @If currentItem.EstatFactura = AppGestio.EnumEstatsFacturaPro.Generada Then
                        @<a href="@Url.Action("Delete", "FacturaPro", New With {.id = currentItem.FacturaProId})">
                            <img src="~/Images/iconos/delete.png" height="20" />
                        </a>
                    End If
                </td>
            </tr>
                    Next

    End If

</table>

