﻿@ModelType AppGestio.ModelLayer.Pressupost

@Code
    ViewData("Title") = String.Format("{0}. {1}", Recursos.pressup_gestiopressupostos, Recursos.pressup_afegir)
End Code

<div>
    <h1>@ViewData("Title")</h1>
</div>

@Using Html.BeginForm()
    @Html.AntiForgeryToken()
    @Html.ValidationSummary(True)

    @<fieldset >
        <legend>Pressupost</legend>

        <table>
            <tr>
                <td width="6%">@Html.Label("Text", "Id:")</td>
                <td width="12%">@Html.TextBoxFor(Function(model) model.PressupostId, New With {.class = "camp-id"})</td>
                <td width="10%">@html.Label("Text",Recursos.camps_client & ":")</td>
                <td width="40%">@Html.DropDownListFor(Function(model) model.ClientId,
                                                      New SelectList(ViewData("clients"), "ClientId", "Nom"))</td>
                <td width="10%">@Recursos.camps_estat :</td>
                <td width="20%">@Html.Label("Text", Model.EstatPressupost.ToString)</td>
            </tr>
        </table>
        <table>
            <tr>
                <td width="15%">
                    @Html.Label("Text", Recursos.camps_descripcio & ":")
                </td>
                <td width="85%">
                    @Html.TextBoxFor(Function(model) model.Descripcio, New With {.class = "camp-descripcio"})
                    @Html.ValidationMessageFor(Function(model) model.Descripcio)
                </td>
            </tr>
        </table>
         <table>
             <tr>
                 <td width="6%">@Html.Label("Text", Recursos.camps_data & ":")</td>
                 <td width="14%">
                 @Html.TextBoxFor(Function(model) model.Data, htmlAttributes:=New With {.class = "datefield", .type = "string", .style = "width: 100px"})
                 @Html.ValidationMessageFor(Function(model) model.Data)
                 </td>
                 <td width="15%">@Html.Label("Text", Recursos.label_descompte & ":")</td>
                 <td width="10%">
                 @Html.TextBoxFor(Function(model) model.PercDescompte, New With {.class = "camp-percdesc"})
                 @Html.ValidationMessageFor(Function(model) model.PercDescompte)
                 </td>
                 <td width="15%">@Html.Label("Text", Recursos.label_num_venc & ":")</td>
                 <td width="10%">
                 @Html.TextBoxFor(Function(model) model.NumVenciments, New With {.class = "camp-numvenc"})
                 @Html.ValidationMessageFor(Function(model) model.NumVenciments)
                 </td>
             </tr>
         </table>

        @If Model.LiniesPressupost IsNot Nothing Then
            @Html.EditorFor(Function(model) model.LiniesPressupost)
        End If

        @*<input type="submit" name="boton" value="@Recursos.button_addLinea" class="marge-taules" />
         <input type="submit" name="boton" value="@Recursos.button_aplicar" class="marge-taules" />*@

        <table>
            <tr>
                <td width="70%"></td>
                <td width="15%">@Html.Label("Text", Recursos.label_suma & ":")</td>
                <td width="15%">@Html.Label(Model.Suma.ToString("N2"))</td>
            </tr>
            <tr>
                <td width="70%"></td>
                <td width="15%">@Html.Label("Text", Recursos.label_IVA & ":")</td>
                <td width="15%">@Html.Label(Model.IVA.ToString("N2"))</td>
            </tr>
            <tr>
                <td width="70%"></td>
                <td width="15%">@Html.Label("Text", Recursos.label_import & ":")</td>
                <td width="15%">@Html.Label(Model.Import.ToString("N2"))</td>
            </tr>
        </table>

         <div class="editor-label">
             @Html.Label("Text", Recursos.label_obs, New With {.class = "marge-taules"})
         </div>
         <div class="editor-field">
             @Html.TextAreaFor(Function(model) model.Observacions, New With {.class = "camp-textarea"})
             @Html.ValidationMessageFor(Function(model) model.Observacions)
         </div>

        <p>
            <input type="submit" name="boton" value="@Recursos.button_guardar" class="marge-taules" />
            <input type="submit" name="boton" value="@Recursos.button_acceptar" class="marge-taules" />
            <input type="submit" name="boton" value="@Recursos.button_anular" class="marge-taules" />
        </p>
</fieldset>
End Using

<div class="marge-taules">
    @Html.ActionLink(Recursos.button_tornarALlista, "Index")
</div>

@Section Scripts
    @Scripts.Render("~/bundles/jqueryval")
End Section
