﻿<!DOCTYPE html>
<html lang="es">
    <head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
        <meta charset="utf-8" />
        <title>@ViewData("Title") - AppGestió</title>
        <link href="~/favicon.ico" rel="shortcut icon" type="image/x-icon" />
        <meta name="viewport" content="width=device-width" />
        @Styles.Render("~/Content/css")

        @Styles.Render("~/Content/themes/base/jquery.ui.core.css")
        @Styles.Render("~/Content/themes/base/jquery.ui.datepicker.css")
        @Styles.Render("~/Content/themes/base/jquery.ui.theme.css")
        
        @Scripts.Render("~/bundles/modernizr")
        @Scripts.Render("~/bundles/jquery")
        @Scripts.Render("~/bundles/jqueryui")
        @Scripts.Render("~/Scripts/DatePickerReady.js")

        @If Culture = "es-ES" Then
            @Scripts.Render("~/Scripts/jquery.ui.datepicker-es.js")
        ElseIf Culture = "ca-ES" Then
            @Scripts.Render("~/Scripts/jquery.ui.datepicker-ca.js")
        End If

        @RenderSection("scripts", required:=False)
    </head>
    <body>
        <header>
            <div class="slogan-quadre">
                <label class="slogan-text">@Recursos.slogan</label>
            </div>
            <div>
                <nav>
                    <div class="float-left">
                        <section id="login">@Html.Partial("_LoginPartial")</section>
                    </div>
                    <ul id="menu">
                        <li>@Html.ActionLink(linkText:="CAT", actionName:="ChangeCulture", controllerName:="Home", routeValues:=New With {.lang = "ca"}, htmlAttributes:=Nothing)</li>
                        <li>@Html.ActionLink(linkText:="ESP", actionName:="ChangeCulture", controllerName:="Home", routeValues:=New With {.lang = "es"}, htmlAttributes:=Nothing)</li>
                        <li>@Html.ActionLink(linkText:="ENG", actionName:="ChangeCulture", controllerName:="Home", routeValues:=New With {.lang = "en"}, htmlAttributes:=Nothing)</li>
                    </ul>
                </nav>
            </div>
            @*<div class="content-wrapper">
                <div class="float-right">
                    <section id="login">
                        @Html.Partial("_LoginPartial")
                    </section>
                    <nav>
                        <ul id="menu">
                            <li>@Html.ActionLink("Inicio", "Index", "Home")</li>
                            <li>@Html.ActionLink("Acerca de", "About", "Home")</li>
                            <li>@Html.ActionLink("Contacto", "Contact", "Home")</li>
                        </ul>
                    </nav>
                </div>
            </div>*@

            <table class="titol-quadre">
                <tr>
                    <th style="text-align:left; border:none"><img class="titol-icono" src="~/Images/iconos/icono.png" /></th>
                    <th style="text-align:center; border:none"><label class="titol-text">@Recursos.nom_empresa</label></th>
                    <th style="text-align:right; border:none"><img class="titol-icono" src="~/Images/iconos/icono.png" /></th>
                </tr>
            </table>
            @If Request.IsAuthenticated Then
              @<table class="apartats-quadre">
                <tr>
                    <th class="apartats-text">@Html.ActionLink(linkText:=Recursos.client_clients, actionName:="Index", controllerName:="Client")</th>
                    <th class="apartats-text">@Html.ActionLink(linkText:=Recursos.proveidor_proveidors, actionName:="Index", controllerName:="Proveedor")</th>
                    <th class="apartats-text">@Html.ActionLink(linkText:=Recursos.camps_estadistiques, actionName:="Index", controllerName:="Estadistiques")</th>
                </tr>
              </table>
              @Html.Partial("_Menu")
            End If
</header>
        <div id="body">
            @RenderSection("featured", required:=False)
            <section class="content-wrapper main-content clear-fix">
                @RenderBody()
            </section>
        </div>
        <footer>
            <div class="content-wrapper">
                <div class="float-left">
                    <p>&copy; @DateTime.Now.Year - Christian Gea Rodenas</p>
                </div>
            </div>
        </footer>
         
        @*@Scripts.Render("~/bundles/jquery")
        @RenderSection("scripts", required:=False)*@
    </body>
</html>
