﻿Imports System.Net.Mail
Imports System.Net
Imports ReminderSVRConfig.Reformes
Imports System.IO
Imports System.Xml.Serialization
Imports System.Text

Public Class Funcions
#Region "Funcions internes"
    Private Shared Function Serialitzar(Of T)(ByVal obj As T) As String
        Try
            Dim xmlString As String = Nothing

            Dim memoryStream As New MemoryStream()
            Dim xs As New XmlSerializer(GetType(T))
            Dim xmlTextWriter As New System.Xml.XmlTextWriter(memoryStream, System.Text.Encoding.UTF8)
            xs.Serialize(xmlTextWriter, obj)
            memoryStream = CType(xmlTextWriter.BaseStream, MemoryStream)

            Dim encoding As System.Text.UTF8Encoding = New System.Text.UTF8Encoding()

            xmlString = encoding.GetString(memoryStream.ToArray())
            memoryStream.Dispose()

            Return xmlString
        Catch

            Return String.Empty
        End Try
    End Function

    Private Shared Function Deserialitzar(ByVal data As String, ByVal ToType As Type) As Object
        Try
            Dim xs As New XmlSerializer(ToType)

            Dim encoding As System.Text.UTF8Encoding = New System.Text.UTF8Encoding()
            Dim b As Byte() = encoding.GetBytes(data)


            Dim memoryStream As New MemoryStream(b)
            Dim xmlTextWriter As New System.Xml.XmlTextWriter(memoryStream, System.Text.Encoding.UTF8)

            Dim theObject As Object = xs.Deserialize(memoryStream)
            memoryStream.Dispose()
            Return theObject

        Catch ex As System.Exception
            Return Nothing
        End Try
    End Function
#End Region

    Public Shared Sub WindowsEvents_Add(ByVal Rutina As String, ByVal mensaje As String, ByVal type As System.Diagnostics.EventLogEntryType)
        Try
            '
            ' Verificar que existeixi el log, sino el creem
            '
            If Not EventLog.SourceExists(My.Application.Info.ProductName) Then
                EventLog.CreateEventSource(My.Application.Info.ProductName, "Application")
            End If
            '
            ' Inicialitzem la classe
            '
            Dim eLog As EventLog = New EventLog
            eLog.Source = My.Application.Info.ProductName
            If eLog.Log <> "Application" Then Exit Sub
            '
            ' Escribimos en el log
            '
            eLog.WriteEntry(String.Format("{0} -----> {1}", Rutina, mensaje), type)
        Catch ex As Exception

        End Try
    End Sub

    Public Shared Sub EnviarEmail(ByRef cfg As MyConfig, ByVal Missatge As String, ByVal Destinataris As String(),
                                  Optional Prioritat As MailPriority = MailPriority.Normal, Optional EsHTML As Boolean = False)

        Dim email As New MailMessage()

        With email
            .Subject = cfg.smtp_subject
            .Body = Missatge 'String.Format("Prueba de envio de mensaje de correo electrónico desde la aplicación {0}", My.Application.Info.ProductName)
            .IsBodyHtml = EsHTML
            .Priority = Prioritat
            .From = New MailAddress(cfg.smtp_frommail, My.Application.Info.ProductName)

            For Each Item As String In Destinataris 'cfg..Split(CChar(";"))
                If Item IsNot Nothing Then .To.Add(New MailAddress(Item))
            Next
        End With

        ' 2. Obrir el canal de comunicació amb el servidor SMTP i demanar que envii el mail
        Dim channel As New SmtpClient()
        With channel
            .Host = cfg.smpt_host
            .Port = cfg.smtp_port
            .EnableSsl = cfg.smtp_ssl
            .Credentials = New NetworkCredential(cfg.smtp_user, cfg.smtp_password)

            ' Enviar el correo
            .Send(email)
        End With
    End Sub

    Public Shared Function GetSeguentHoraInici(ByRef cfg As MyConfig) As Date
        Dim hora As Date = cfg.HoraComprobacio
        Dim res As Date = Now

        If TimeSerial(Now.Hour, Now.Minute, Now.Second) < TimeSerial(hora.Hour, hora.Minute, hora.Second) Then
            'Si ara es avans de la hora d'inici, ha de ser a la hora d'inici
            res = New Date(Now.Year, Now.Month, Now.Day, hora.Hour, hora.Minute, hora.Second)
        Else
            'Si hem sobrepassat la hora d'inici, comprovem la hora final i la freqüencia
            If cfg.Freqüencia = 0 OrElse TimeSerial(cfg.HoraFiComprovacio.Hour, cfg.HoraFiComprovacio.Minute, cfg.HoraFiComprovacio.Second) < TimeSerial(Now.Hour, Now.Minute, Now.Second) Then
                'És un cop al dia, o ens hem passat de la hora final, ha de ser demà a la hora inici.
                res = New Date(Now.AddDays(1).Year, Now.AddDays(1).Month, Now.AddDays(1).Day, hora.Hour, hora.Minute, hora.Second)
            Else
                'Si hi ha freqüencia, comprovem la següent
                res = New Date(Now.Year, Now.Month, Now.Day, hora.Hour, hora.Minute, hora.Second)

                While res < Now
                    res = res.AddMinutes(cfg.Freqüencia)
                End While

                ' si sobrepassem la hora final, ha de ser demà a la hora inici, si no, res ja es la hora correcte
                If TimeSerial(res.Hour, res.Minute, res.Second) > TimeSerial(cfg.HoraFiComprovacio.Hour, cfg.HoraFiComprovacio.Minute, cfg.HoraFiComprovacio.Second) Then
                    res = New Date(Now.AddDays(1).Year, Now.AddDays(1).Month, Now.AddDays(1).Day, hora.Hour, hora.Minute, hora.Second)
                End If


            End If
        End If

        Return res
    End Function



    Public Shared Function GetParams() As MyConfig
        Dim cfg As MyConfig

        If IO.File.Exists(ConfigFileNom) Then
            Dim dades As String = My.Computer.FileSystem.ReadAllText(ConfigFileNom)
            cfg = CType(Deserialitzar(dades, GetType(MyConfig)), MyConfig)
        Else
            cfg = New MyConfig
        End If

        'Dim client As New ReformesServiceClient()
        'Dim Lista() As Configuracio = client.GetConfiguracioReminder

        'For Each c As Configuracio In Lista
        '    Try
        '        Select Case c.Opcio.ToLower
        '            Case "rem_horaini" : cfg.HoraComprobacio = CDate(c.Valor)
        '            Case "rem_horafin" : cfg.HoraFiComprovacio = CDate(c.Valor)
        '            Case "rem_freq" : cfg.Freqüencia = CInt(c.Valor)
        '            Case "rem_dias" : cfg.DiesEntreEnviaments = CInt(c.Valor)
        '            Case "rem_smtp_host" : cfg.smpt_host = c.Valor
        '            Case "rem_smtp_frommail" : cfg.smtp_frommail = c.Valor
        '            Case "rem_smtp_password" : cfg.smtp_password = c.Valor
        '            Case "rem_smtp_port" : cfg.smtp_port = CInt(c.Valor)
        '            Case "rem_smtp_ssl" : cfg.smtp_ssl = (c.Valor = "1")
        '            Case "rem_smtp_subject" : cfg.smtp_subject = c.Valor
        '            Case "rem_smtp_user" : cfg.smtp_user = c.Valor
        '        End Select
        '    Catch ex As Exception
        '    End Try
        'Next

        Return cfg
    End Function

    Public Shared Sub SetParams(cfg As MyConfig)

        Dim dades As String = Serialitzar(Of MyConfig)(cfg)

        If IO.File.Exists(ConfigFileNom) Then IO.File.Delete(ConfigFileNom)
        My.Computer.FileSystem.WriteAllText(ConfigFileNom, dades, False)

        'Dim client As New ReformesServiceClient()
        'Dim Lista(10) As Configuracio
        'Lista(0) = New Configuracio With {.UsuariId = -1, .Opcio = "rem_horaini", .Valor = cfg.HoraComprobacio}
        'Lista(1) = New Configuracio With {.UsuariId = -1, .Opcio = "rem_horafin", .Valor = cfg.HoraFiComprovacio}
        'Lista(2) = New Configuracio With {.UsuariId = -1, .Opcio = "rem_freq", .Valor = cfg.Freqüencia}
        'Lista(3) = New Configuracio With {.UsuariId = -1, .Opcio = "rem_dias", .Valor = cfg.DiesEntreEnviaments}
        'Lista(4) = New Configuracio With {.UsuariId = -1, .Opcio = "rem_smtp_host", .Valor = cfg.smpt_host}
        'Lista(5) = New Configuracio With {.UsuariId = -1, .Opcio = "rem_smtp_frommail", .Valor = cfg.smtp_frommail}
        'Lista(6) = New Configuracio With {.UsuariId = -1, .Opcio = "rem_smtp_password", .Valor = cfg.smtp_port}
        'Lista(7) = New Configuracio With {.UsuariId = -1, .Opcio = "rem_smtp_port", .Valor = cfg.smtp_port}
        'Lista(8) = New Configuracio With {.UsuariId = -1, .Opcio = "rem_smtp_ssl", .Valor = If(cfg.smtp_ssl, "1", "0")}
        'Lista(9) = New Configuracio With {.UsuariId = -1, .Opcio = "rem_smtp_subject", .Valor = cfg.smtp_subject}
        'Lista(10) = New Configuracio With {.UsuariId = -1, .Opcio = "rem_smtp_user", .Valor = cfg.smtp_user}

        'client.SetConfiguracioReminder(Lista)
    End Sub
End Class
Public Enum EstatsServei
    NoInstalat
    Actiu
    NoActiu
End Enum
