﻿Public Class Service1
    Private WithEvents _timer As System.Timers.Timer
    Private cfg As MyConfig

    Protected Overrides Sub OnStart(ByVal args() As String)
        ' Agregue el código aquí para iniciar el servicio. Este método debería poner
        ' en movimiento los elementos para que el servicio pueda funcionar.
        Me._timer = New Timers.Timer
        Me.cfg = Funcions.GetParams

        'Calculem la següent hora a la que el timer ha d'activar-se
        Me._timer.Interval = (Funcions.GetSeguentHoraInici(Me.cfg) - Now).TotalMilliseconds
        Me._timer.Enabled = True
    End Sub

    Protected Overrides Sub OnStop()
        ' Agregue el código aquí para realizar cualquier anulación necesaria para detener el servicio.
        Me._timer.Enabled = False
        Me._timer.Dispose()
        Me._timer = Nothing
    End Sub

    Private Sub _timer_Elapsed(sender As Object, e As Timers.ElapsedEventArgs) Handles _timer.Elapsed
        'bla bla

        Try
            Me._timer.Enabled = False

            Dim client As New ReminderSVR.ReformesServiceClient
            Dim LAvis() As ReminderSVR.Reformes.Avis = client.GetAvisos(Me.cfg.DiesEntreEnviaments)
            Dim LRespostes As New List(Of ReminderSVR.Reformes.RespostaAvis)
            Dim re As ReminderSVR.Reformes.RespostaAvis
            Dim msg As String

            For Each av As ReminderSVR.Reformes.Avis In LAvis
                re = New Reformes.RespostaAvis
                re.idTransaccio = av.idTransaccio
                re.Factura = av.Factura

                Try
                    msg = String.Format("Att: {3} {4}{5} Recordatori de pagament de la Factura {0}. L'import es: '{1}' i la data de venciment era el dia: {2}",
                                      av.Factura, av.Import, av.Venciment.ToLongDateString, av.NomPersona, vbNewLine)


                    Funcions.EnviarEmail(Me.cfg, msg, New String() {av.EmailEnvio}, Net.Mail.MailPriority.High)


                    re.Enviat = True
                    re.Missatge = "OK"
                Catch ex As Exception
                    re.Enviat = False
                    re.Missatge = ex.Message
                End Try

                LRespostes.Add(re)

            Next

            client.SetAvisosRespostes(LRespostes.ToArray)

        Catch ex As Exception

        Finally
            'Calculem la següent hora a la que el timer ha d'activar-se
            Me._timer.Interval = (Funcions.GetSeguentHoraInici(Me.cfg) - Now).TotalMilliseconds
            Me._timer.Enabled = True
        End Try
    End Sub
End Class
