﻿Imports System.Net
Imports System.Net.Mail

Public Class Form1
    Dim cfg As MyConfig


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.cfg = Funcions.GetParams
        Me.MyConfigBindingSource.DataSource = Me.cfg

        EstatDelServei()

    End Sub


#Region "Funcions del servei"
    Private Function EstatDelServei() As EstatsServei
        Dim SvrController As New System.ServiceProcess.ServiceController(NomServei)
        Try
            If SvrController.Status = ServiceProcess.ServiceControllerStatus.Running Then
                Me.lblEstado.BackColor = Color.Green
                Me.lblEstado.Text = "Servicio iniciado"
                Me.btnParar.Enabled = True
                Me.btnIniciar.Enabled = False
                Me.btnInstalar.Enabled = False
                Me.btnDesinstalar.Enabled = True
                Return EstatsServei.Actiu
            Else
                Me.lblEstado.BackColor = Color.Red
                Me.lblEstado.Text = "Servicio parado"
                Me.btnParar.Enabled = False
                Me.btnIniciar.Enabled = True
                Me.btnInstalar.Enabled = True
                Me.btnDesinstalar.Enabled = False
                Return EstatsServei.NoActiu
            End If
        Catch ex As Exception
            Me.lblEstado.BackColor = Color.Transparent
            Me.lblEstado.Text = "Servicio no instalado"
            Me.btnParar.Enabled = False
            Me.btnIniciar.Enabled = False
            Me.btnInstalar.Enabled = True
            Me.btnDesinstalar.Enabled = False
            Return EstatsServei.NoInstalat
        End Try
    End Function

    Private Function IniciarServicio() As Boolean
        Dim EstaEnMemoria As Boolean = True
        Dim SvrController As New System.ServiceProcess.ServiceController(NomServei)
        Try
            'Si esta instalado 
            If SvrController.Status = ServiceProcess.ServiceControllerStatus.Running Then
                'MessageBox.Show("el Servicio ya estaba Activo")
            Else
                SvrController.Start()
                SvrController.WaitForStatus(ServiceProcess.ServiceControllerStatus.Running, New System.TimeSpan(0, 0, 30))
            End If
            Me.btnParar.Enabled = True
            Me.btnIniciar.Enabled = False
            Me.EstatDelServei()
        Catch ex As InvalidOperationException
            If ex.ToString.Contains("Access is denied") Then
                MessageBox.Show("No tiene permisos para iniciar el servicio.", My.Application.Info.Title, MessageBoxButtons.OK, MessageBoxIcon.Warning)
            Else
                MessageBox.Show("El Servicio no está instalado.", My.Application.Info.Title, MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If
        Catch ex As Exception
            Funcions.WindowsEvents_Add("Iniciar Servicio", ex.ToString, EventLogEntryType.Error)
            MessageBox.Show(ex.ToString, My.Application.Info.Title, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        End Try


        Return True
    End Function

    Private Sub InstalarServicio(Optional ByVal Desinstalar As Boolean = False, Optional ByVal bOmitirMsg As Boolean = False)
        Dim argum(0) As String
        Dim ruta As String = System.IO.Path.Combine(My.Application.Info.DirectoryPath, NomServei)
        If System.IO.File.Exists(ruta) = False Then
            Dim sb As New System.Text.StringBuilder
            sb.AppendLine("No se encuentra el ejecutable '" & NomServei & "' en el mimso directorio que el de configuracion.")
            sb.AppendLine("No puede continuar con el proceso. Revise la instalación.")

            Funcions.WindowsEvents_Add("InstalarServicio", sb.ToString, EventLogEntryType.Error)
            MessageBox.Show(sb.ToString, "Error al instalar el servicio", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End If

        Try
            If Desinstalar Then
                ' Si el servicio no esta instalado, salimos
                If EstatDelServei() = EstatsServei.NoInstalat Then Exit Try

                Dim newProc As Diagnostics.Process = Diagnostics.Process.Start(ruta, "/uninstall")
                newProc.WaitForExit()

                Funcions.WindowsEvents_Add("InstalarServicio", "Desinstalacion del servicio de comunicaciones realizada correctamente", EventLogEntryType.Information)
                If Not bOmitirMsg Then MessageBox.Show("Desinstalacion del servicio de comunicaciones realizada correctamente", "Desinstalar servicio", MessageBoxButtons.OK, MessageBoxIcon.Information)

            Else
                Dim newProc As Diagnostics.Process = Diagnostics.Process.Start(ruta, "/install")
                newProc.WaitForExit()

            End If
        Catch ex As InvalidOperationException
            If ex.ToString.Contains("Access is denied") Then
                MessageBox.Show("No tiene permisos para detener el servicio.", My.Application.Info.Title, MessageBoxButtons.OK, MessageBoxIcon.Warning)
                Funcions.WindowsEvents_Add("InstalarServicio", "No tiene permisos para detener el servicio.: " & ex.ToString, EventLogEntryType.Warning)
            Else
                MessageBox.Show(ex.ToString, My.Application.Info.Title, MessageBoxButtons.OK, MessageBoxIcon.Warning)
                Funcions.WindowsEvents_Add("InstalarServicio", ex.ToString, EventLogEntryType.Warning)
            End If


        Catch ex As Exception
            'SI NO LO INSTALA/Desinstala: ..

            If Desinstalar Then
                Dim sb As New System.Text.StringBuilder
                sb.AppendLine("No se pudo desinstalar el servicio. Mensaje de error: ")
                sb.AppendLine(ex.ToString)

                Funcions.WindowsEvents_Add("InstalarServicio", sb.ToString, EventLogEntryType.Information)
                MessageBox.Show(sb.ToString, "Desinstalar Servicio", MessageBoxButtons.OK, MessageBoxIcon.Error)

            Else
                Dim sb As New System.Text.StringBuilder
                sb.AppendLine("No se pudo instalar el servicio. Mensaje de error: ")
                sb.AppendLine(ex.ToString)

                Funcions.WindowsEvents_Add("InstalarServicio", sb.ToString, EventLogEntryType.Information)
                MessageBox.Show(sb.ToString, "Instalación Servicio", MessageBoxButtons.OK, MessageBoxIcon.Error)

            End If
        End Try
    End Sub

    Private Sub PararServicio()
        Dim SvrController As New System.ServiceProcess.ServiceController(NomServei)
        Try
            'Si esta instalado 
            If SvrController.Status = ServiceProcess.ServiceControllerStatus.Stopped Then
                'MessageBox.Show("el Servicio ya estaba parado")
            Else
                If SvrController.CanStop Then
                    SvrController.Stop()

                    SvrController.WaitForStatus(ServiceProcess.ServiceControllerStatus.Stopped, New System.TimeSpan(0, 0, 30))
                End If
            End If
            Me.btnParar.Enabled = False
            Me.btnIniciar.Enabled = True
            Me.EstatDelServei()

        Catch ex As InvalidOperationException
            'No esta instalado, instalarlo
            'Si no esta instalado, no hacer nada

            If ex.ToString.Contains("Access is denied") Then
                MessageBox.Show("No tiene permisos para detener el servicio. Hable con el administrador del sistema.", My.Application.Info.Title, MessageBoxButtons.OK, MessageBoxIcon.Warning)
            End If
        Catch ex As Exception
            Funcions.WindowsEvents_Add("Parar servicio", ex.ToString, EventLogEntryType.Warning)
        End Try
    End Sub
#End Region

    Private Sub btnIniciar_Click(sender As Object, e As EventArgs) Handles btnIniciar.Click
        Me.IniciarServicio()
        Me.EstatDelServei()
    End Sub

    Private Sub btnParar_Click(sender As Object, e As EventArgs) Handles btnParar.Click
        Me.PararServicio()
        Me.EstatDelServei()
    End Sub

    Private Sub btnSMTPCheck_Click(sender As Object, e As EventArgs) Handles btnSMTPCheck.Click
        Me.Cursor = Cursors.WaitCursor

        Try
            Funcions.EnviarEmail(cfg,
                                 String.Format("Prueba de envio de mensaje de correo electrónico desde la aplicación {0}", My.Application.Info.ProductName),
                                 Me.txtSMTPDestinatario.Text.Split(CChar(";")),
                                 MailPriority.Low, False)

            MessageBox.Show("Mensaje enviado correctamente", "Envio de correo electrónico", MessageBoxButtons.OK, MessageBoxIcon.Information)

        Catch ex As Exception
            MessageBox.Show(String.Format("Error al enviar el correo electrónico." & vbCrLf & vbCrLf & "{0}", ex.Message.ToString), "Envio de correo electrónico", MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
        End Try

        Me.Cursor = Cursors.Default
    End Sub

    Private Sub btnSortir_Click(sender As Object, e As EventArgs) Handles btnSortir.Click, btnDesar.Click

        If sender Is btnDesar Then
            Funcions.SetParams(Me.cfg)
        End If

        Me.Close()
    End Sub

    Private Sub btnInstalar_Click(sender As Object, e As EventArgs) Handles btnInstalar.Click
        Me.InstalarServicio()
        Me.EstatDelServei()
    End Sub

    Private Sub btnDesinstalar_Click(sender As Object, e As EventArgs) Handles btnDesinstalar.Click
        Me.InstalarServicio(True)
        Me.EstatDelServei()
    End Sub
End Class
