﻿Imports System.Data.SqlClient



Friend NotInheritable Class DAOFactory

#Region "Constructor"
    'Constructor con visibilidad privada
    Private Sub New()

    End Sub
#End Region

#Region "Metodos"


    Public Shared Function IsValidProveidor(ByVal UserName As String, Pass As String, ByRef idProv As Double, ByRef NomProveidor As String) As Boolean

        NomProveidor = ""
        Dim dt As New DataTable

        Try
            dt = GetTable("Select ProveidorId, Nom from dbo.PROVEIDORS where NomUsuariWeb='" & UserName & "' and ContrasenyaWeb='" & Pass & "' and ActivatEnWeb<>0 ")
        Catch ex As Exception
            Return False
        End Try

        If dt Is Nothing Then
            Return False
        Else
            If dt.Rows.Count = 0 Then
                Return False
            Else
                idProv = If(dt.Rows(0).IsNull("ProveidorId"), -1, CInt(dt.Rows(0)("ProveidorId")))
                NomProveidor = If(dt.Rows(0).IsNull("Nom"), "", dt.Rows(0)("Nom").ToString)


                Return (idProv > -1)
            End If
        End If
    End Function


    Public Shared Function SetFactura(ProveidorID As Long, NomFitxer As String, longitud As Long, ContentType As String, data As String,
                              nif As String, datafactura As Date, import As Double) As Long

        Try
            'Dim str As String = String.Format("INSERT INTO dbo.document (ProveidorId, Nom, Longitud, ContentType, dades, nif, DataFactura, import, Estat) " & _
            '                                  "VALUES ({0}, {1}, '{2}', '{3}', '{4}', '{5}', '{6}', '{7}', 0)",
            '                                  ProveidorID, NomFitxer, longitud, ContentType, "", nif, datafactura.ToString("yyyyMMdd"), Format(import, "0.00"))

            'If ExecuteNonQuery(str) = 0 Then Return False

            Dim str As String = "INSERT INTO dbo.document (ProveidorId, Nom, Longitud, ContentType, dades, nif, DataFactura, import, Estat) " & _
                                              "VALUES (@pro, @nom, @long, @cont, @dades, @nif, @dataf, @import, @estat)"

            Dim cmd As SqlClient.SqlCommand = GetCommand()

            cmd.Parameters.Add("@pro", SqlDbType.BigInt)
            cmd.Parameters("@pro").Value = ProveidorID

            cmd.Parameters.Add("@nom", SqlDbType.NVarChar)
            cmd.Parameters("@nom").Value = NomFitxer

            cmd.Parameters.Add("@long", SqlDbType.BigInt)
            cmd.Parameters("@long").Value = longitud

            cmd.Parameters.Add("@cont", SqlDbType.NVarChar)
            cmd.Parameters("@cont").Value = ContentType

            cmd.Parameters.Add("@dades", SqlDbType.NVarChar)
            cmd.Parameters("@dades").Value = data

            cmd.Parameters.Add("@nif", SqlDbType.NVarChar)
            cmd.Parameters("@nif").Value = nif

            cmd.Parameters.Add("@dataf", SqlDbType.DateTime)
            cmd.Parameters("@dataf").Value = datafactura

            cmd.Parameters.Add("@import", SqlDbType.Float)
            cmd.Parameters("@import").Value = import

            cmd.Parameters.Add("@estat", SqlDbType.Int)
            cmd.Parameters("@estat").Value = 0

            cmd.CommandText = str

            If cmd.ExecuteNonQuery = 1 Then
                'Buscar el màxim id de fitxer.
                'Ens assegurem que  no es creua amb el d'un altre proveidor que estigui enviant en aquest mateix moment.
                cmd.Parameters.Clear()
                cmd.CommandText = "SELECT MAX(Id) FROM dbo.document where proveidorId=" & ProveidorID
                'Acabem d'insertar un, així que no hauria de ser mai null
                Return CLng(cmd.ExecuteScalar)
            Else
                Return -1
            End If

        Catch ex As Exception
            Return False
        End Try
    End Function

    Public Shared Function AddDataToFacturaPro(FileId As Long, data As String) As Boolean
        Try
            Dim str As String = "UPDATE dbo.document SET dades=dades + @dades WHERE Id=@Id"

            Dim cmd As SqlClient.SqlCommand = GetCommand()

            cmd.Parameters.Add("@Id", SqlDbType.BigInt)
            cmd.Parameters("@Id").Value = FileId

            cmd.Parameters.Add("@dades", SqlDbType.NVarChar)
            cmd.Parameters("@dades").Value = data

            cmd.CommandText = str

            Return (cmd.ExecuteNonQuery = 1)

        Catch ex As Exception
            Return False
        End Try
    End Function


#Region "Configuració"
    Public Shared Function GetConfiguracioReminder() As List(Of Configuracio)
        Dim L As New List(Of Configuracio)
        Try
            Dim dt As DataTable = GetTable("SELECT * FROM dbo.CONFIGURACIONS Where Opcio Like 'rem_%'")
            If dt IsNot Nothing AndAlso dt.Rows.Count > 0 Then
                For Each dr As DataRow In dt.Rows
                    Try
                        L.Add(New Configuracio With {
                                                  .Opcio = dr("Opcio").ToString,
                                                  .UsuariId = -1,
                                                  .Valor = If(dr.IsNull("valor"), "", CStr(dr("valor")))})
                    Catch ex As Exception
                    End Try
                Next
            End If
        Catch ex As Exception
        End Try

        Return L
    End Function

    Public Shared Function SetConfiguracioReminder(oLista As List(Of Configuracio)) As Boolean

        Try
            ExecuteNonQuery("DELETE FROM dbo.CONFIGURACIONS Where Opcio Like 'rem_%")
        Catch ex As Exception
        End Try

        Try

            If oLista IsNot Nothing AndAlso oLista.Count > 0 Then
                Dim sb As New System.Text.StringBuilder

                For Each c As Configuracio In oLista
                    sb.AppendFormat("INSERT INTO dbo.Configuracio (UsuariId, Opcio, Valor) VALUES (-1, '{0}', {1});",
                                    c.Opcio, c.Valor)


                Next

                ExecuteNonQuery(sb.ToString)

            End If
        Catch ex As Exception
            Return False
        End Try

        Return True
    End Function

    Public Shared Function GetAvisos(CantDiesEntreAvisos As Integer) As List(Of Avis)

        Dim L As New List(Of Avis)

        Dim sb As New System.Text.StringBuilder

        Try
            sb.AppendFormat("SELECT cl.*, cl.Email, cl.Nom FROM dbo.COBRAMENTS As co INNER JOIN cbo.CLIENTS As cl ON co.ClientId=cl.ClientId " & _
                            "WHERE co.Estat=0 and (co.UltimaReclamacio IS NULL OR DATEDIFF(day, co.UltimaReclamacio, GETDATE()) >= {0}) AND  " & _
                            "co.DataVenciment < GETDATE() AND cl.Email IS NOT NULL",
                            CantDiesEntreAvisos)

            Dim dt As DataTable = GetTable(sb.ToString)

            If dt IsNot Nothing AndAlso dt.Rows.Count > 1 Then
                For Each dr As DataRow In dt.Rows
                    Try
                        L.Add(New Avis With {
                     .TipusAvis = EnumTipusAvis.Client,
                     .idTransaccio = dr("Id"),
                     .Factura = CInt(dr("FacturaCliId")),
                     .DataFactura = CDate(If(dr.IsNull("DataFactura"), Date.MinValue, dr("DataFactura"))),
                     .Import = CDbl(dr("Import")),
                     .NomPersona = CStr(If(dr.IsNull("Nom"), "", dr("Nom"))),
                     .Venciment = CDate(If(dr.IsNull("DataVenciment"), Date.MinValue, dr("DataVenciment"))),
                     .EmailEnvio = CStr(dr("Email"))})
                    Catch ex As Exception
                    End Try
                Next
            End If

        Catch ex As Exception
        End Try

        Try

            sb.AppendFormat("SELECT cl.*, cl.Email, cl.Nom FROM dbo.PAGAMENTS As co INNER JOIN cbo.PROVEIDOR As cl ON co.ProveidorId=cl.ProveidorId " & _
                            "WHERE c.Estat=0 and (co.UltimaReclamacio IS NULL OR DATEDIFF(day, co.UltimaReclamacio, GETDATE()) >= {0}) AND  " & _
                            "co.DataVenciment < GETDATE() AND cl.Email IS NOT NULL",
                            CantDiesEntreAvisos)

            Dim dt As DataTable = GetTable(sb.ToString)

            If dt IsNot Nothing AndAlso dt.Rows.Count > 1 Then
                For Each dr As DataRow In dt.Rows
                    Try
                        L.Add(New Avis With {
                     .TipusAvis = EnumTipusAvis.Proveidor,
                     .idTransaccio = dr("Id"),
                     .Factura = CInt(dr("FacturaProId")),
                     .DataFactura = CDate(If(dr.IsNull("DataFactura"), Date.MinValue, dr("DataFactura"))),
                     .Import = CDbl(dr("Import")),
                     .NomPersona = CStr(If(dr.IsNull("Nom"), "", dr("Nom"))),
                     .Venciment = CDate(If(dr.IsNull("DataVenciment"), Date.MinValue, dr("DataVenciment"))),
                     .EmailEnvio = CStr(dr("Email"))})
                    Catch ex As Exception
                    End Try
                Next
            End If



        Catch ex As Exception
        End Try

        Return L
    End Function

    Public Shared Function SetAvisosRespostes(oLista As List(Of RespostaAvis)) As Boolean

        Try
            For Each R As RespostaAvis In oLista
                Try
                    If R.TipusAvis = EnumTipusAvis.Client Then

                        ExecuteNonQuery(String.Format("UPDATE COBRAMENTS SET UltimaReclamacio=GETDATE(), Enviat={0}, Missatge='{1}' WHERE idTransaccio={2}",
                                                      If(R.Enviat, "1", "0"), R.Missatge, R.idTransaccio))
                    Else
                        ExecuteNonQuery(String.Format("UPDATE PAGAMENTS SET UltimaReclamacio=GETDATE(), Enviat={0}, Missatge='{1}' WHERE idTransaccio={2}",
                                                      If(R.Enviat, "1", "0"), R.Missatge, R.idTransaccio))

                    End If
                Catch ex As Exception
                End Try
            Next

        Catch ex As Exception
            Return False
        End Try

        Return True
    End Function

#End Region

#End Region

#Region "BaseDeDades"
    Private Shared oCnn As SqlClient.SqlConnection

    Private Shared Function OpenConnection() As Boolean
        If oCnn Is Nothing Then
            oCnn = New SqlClient.SqlConnection(My.Settings.cnn_str)
        End If

        If oCnn.State <> ConnectionState.Open Then
            oCnn.Open()
        End If

        Return oCnn.State = ConnectionState.Open

    End Function

    Private Shared Function GetCommand() As SqlClient.SqlCommand
        If OpenConnection() Then
            Return New SqlClient.SqlCommand("", oCnn)
        End If

        Return Nothing
    End Function

    Private Shared Function GetTable(sqlText As String) As DataTable
        Dim dt As New DataTable
        If OpenConnection() Then
            Dim da As New SqlDataAdapter(sqlText, oCnn)
            da.Fill(dt)
        End If

        Return dt
    End Function

    Private Shared Function ExecuteScalar(sqlText As String) As Object
        Dim cmd As SqlClient.SqlCommand = GetCommand()
        cmd.CommandText = sqlText
        Return cmd.ExecuteScalar
    End Function

    Private Shared Function ExecuteNonQuery(sqlText As String) As Integer
        Dim cmd As SqlClient.SqlCommand = GetCommand()
        cmd.CommandText = sqlText
        Return cmd.ExecuteNonQuery
    End Function

#End Region

    

End Class

